"""
Which one is faster?
lgamma(n+1)/ln(2) or sum log(i) from i = 1..n ?
"""

from prolothar_common.experiments.stopwatch import Stopwatch
from experiments.result_collector import ResultCollector

from scipy.special import gammaln as lgamma
from math import log as ln
from math import log2

list_of_n = list(range(1, 200, 10))
n_repetitions = 10000

stopwatch = Stopwatch()

for n in list_of_n:
    stopwatch.start()
    for _ in range(n_repetitions):
        x = lgamma(n+1) / ln(2)
    x_time = stopwatch.get_elapsed_time()

    stopwatch.start()
    for _ in range(n_repetitions):
        x = lgamma(n+1) / ln(2)
        y = 0
        for i in range(1,n+1):
            y += log2(i)
    y_time = stopwatch.get_elapsed_time()
    print((x,y))
    print((x_time,y_time))