from typing import List

from prolothar_rule_mining.models.event_flow_graph import EventFlowGraph
from prolothar_rule_mining.models.event_flow_graph.alignment.alignment import Alignment

cdef class AlignmentFinder:
    """
    abstract definition of an alignment finder for a given graph
    """

    def __init__(self, graph: EventFlowGraph):
        self.graph = graph

    def compute_alignment(self, sequence: List[str]) -> Alignment:
        """
        computes an alignment for the given sequence, i.e. a way through the
        graph and the sequence that makes minimal mistakes on both
        """
        raise NotImplementedError()
