"""
this module contains the Edge model of an EventFlowGraph
"""

from prolothar_rule_mining.models.event_flow_graph.node import Node

class Edge:
    """
    edge of a an event flow graph. the edge has a from and a to node
    """
    __slots__ = ('from_node', 'to_node', 'attributes')

    def __init__(self, from_node: Node, to_node: Node):
        self.from_node = from_node
        self.to_node = to_node
        self.attributes = {}

    def __hash__(self) -> int:
        return hash((self.from_node, self.to_node))

    def __eq__(self, other: 'Edge') -> int:
        return self is other or (
            self.from_node == other.from_node and self.to_node == other.to_node)

    def __repr__(self) -> str:
        return '(%r, %r)' % (self.from_node, self.to_node)
