from prolothar_common.models.dataset import TargetSequenceDataset
from prolothar_rule_mining.models.converter.sequence_to_class_dataset_converter import SequenceToClassDatasetConverter

from prolothar_rule_mining.rule_miner.data_to_sequence.rules import Rule
from prolothar_rule_mining.rule_miner.data_to_sequence.rules import ClassificationRule

class ClassificationMiner():
    """
    reduces the sequence prediction task to a classification task, i.e. each
    unique sequence in the dataset corresponds to one class
    """

    def __init__(self, classification_miner):
        self.__classification_miner = classification_miner

    def mine_rules(self, dataset: TargetSequenceDataset) -> Rule:
        sequence_to_class_converter = SequenceToClassDatasetConverter(dataset)
        classification_rule = self.__classification_miner.mine_rules(
            sequence_to_class_converter.get_converted_dataset())
        return ClassificationRule(
            classification_rule,
            sequence_to_class_converter.get_class_to_sequence_mapping())