import numpy as np

def batch_generator(
        X, Y, batch_size: int, shuffle: bool = True,
        return_smaller_last_batch: bool = True):
    indices = np.arange(len(X))
    if shuffle:
        np.random.shuffle(indices)
    batch = []
    for i in indices:
        batch.append(i)
        if len(batch) == batch_size:
            yield X[batch], Y[batch]
            batch = []
    if return_smaller_last_batch and batch:
        yield X[batch], Y[batch]
