"""
this module contains the event flow graph miner, i.e. for a given dataset an
event flow graph is inferred
"""

from abc import ABC, abstractmethod

from prolothar_common.models.dataset import TargetSequenceDataset
from prolothar_rule_mining.models.event_flow_graph import EventFlowGraph

class EventFlowGraphMiner(ABC):
    """
    infers an EventFlowGraph from a given sequential dataset.
    """

    @abstractmethod
    def mine_event_flow_graph(self, dataset: TargetSequenceDataset) -> EventFlowGraph:
        """
        infers an EventFlowGraph from a given sequential dataset.
        """
