"""
this module contains an Oracle event flow graph miner, i.e. for a given dataset a
already specified event flow graph (e.g. the true model generating the data) is
returned
"""

from prolothar_rule_mining.models.event_flow_graph import EventFlowGraph

from prolothar_common.models.dataset import TargetSequenceDataset

from prolothar_rule_mining.rule_miner.data_to_sequence.rudi.event_flow_graph_miner.abstract import EventFlowGraphMiner

class OracleEventFlowGraphMiner(EventFlowGraphMiner):
    """
    for a given dataset a
    already specified event flow graph (e.g. the true model generating the data) is
    returned
    """

    def __init__(self, event_flow_graph: EventFlowGraph):
        """
        creates a new EventFlowGraphMiner
        """
        self.__event_flow_graph = event_flow_graph

    def mine_event_flow_graph(self, dataset: TargetSequenceDataset) -> EventFlowGraphMiner:
        return self.__event_flow_graph

    def __repr__(self) -> str:
        return 'OracleEventFlowGraphMiner()'