from typing import List
from abc import ABC, abstractmethod

class BlackboxRule(ABC):
    """
    a rule interface for a blackbox model, where the only possible methods of a
    rule are its execution on an instance
    """
    @abstractmethod
    def execute(self, instance) -> List[str]:
        """generates a sequence for the given instance as input"""