from typing import List, Generator

from graphviz import Digraph

from prolothar_common.models.dataset.instance import Instance

from prolothar_rule_mining.rule_miner.data_to_sequence.rules.rule import Rule
from prolothar_rule_mining.rule_miner.data_to_sequence.rules.rule import Backtrace

class RuleLiteral(Rule):
    """
    base class for rules without subrules
    """
    def yield_subrules(self) -> Generator['Rule', None, None]:
        #there are no subrules
        return
        yield

    def count_nr_of_terms(self) -> int:
        return 0

    def appears_in_sequence(self, sequence: List[str]) -> bool:
        """returns True iff this rule literal appears in the given sequence"""
        pass

    def _execute_with_backtrace(
            self, parent: 'ListOfRules', index: int, instance: Instance,
            sequence: List[str], backtrace: Backtrace):
        self._execute(instance, sequence)
        backtrace.append((parent, self, index))

    def _add_to_digraph(self, graph: Digraph) -> List[str]:
        graph.node(str(id(self)), label=str(self))
        return [str(id(self))]
