from typing import Union

from prolothar_common.models.eventlog import EventLog, Trace

class MajorityEventPredictor:
    """
    always predicts the most frequent event in the trainset as the next event
    """

    def __init__(self):
        self.__majority_class: Union[str, None] = None

    def train(self, eventlog: EventLog):
        activity_supports = eventlog.compute_activity_supports()
        self.__majority_class = max(activity_supports.items(), key=lambda x: x[1])[0]

    def predict(self, prefix_trace: Trace) -> str:
        return self.__majority_class
