# -*- coding: utf-8 -*-

import pathlib
from setuptools import setup
 
# The directory containing this file
HERE = pathlib.Path(__file__).parent
 
# The text of the README file
README = (HERE / "README.md").read_text()
 
with open('version.txt', 'r') as f:
    version = f.read().strip()

# This call to setup() does all the work
setup(
    name="dh-experiment-logger",
    version=version,
    description="Provides a logger for convenient recording of experiments",
    long_description=README,
    long_description_content_type="text/markdown",
    url="https://gitlab.dillinger.de/KI/DataScience/utils/dh-experiment-logger",
    author="Boris Wiegand",
    author_email="boris.wiegand@dillinger.biz",
    classifiers=[
        "Programming Language :: Python :: 3",
        "Programming Language :: Python :: 3.7",
        "Topic :: Utilities"
    ],
    packages=["experimentlogger"],
    include_package_data=True,
    install_requires=[]
)
