# -*- coding: utf-8 -*-

import pathlib
from setuptools import setup, find_namespace_packages
 
# The directory containing this file
HERE = pathlib.Path(__file__).parent
 
# The text of the README file
README = (HERE / "README.md").read_text()
 
with open('requirements.txt', 'r') as f:
    install_reqs = [
        s for s in [
            line.split('#', 1)[0].strip(' \t\n') for line in f
        ] if s != ''
    ]

with open('version.txt', 'r') as f:
    version = f.read().strip()

# This call to setup() does all the work
setup(
    name="dh-parallel",
    version=version,
    description="Utils for parallel computations with different backends",
    long_description=README,
    long_description_content_type="text/markdown",
    url="https://gitlab.dillinger.de/KI/DataScience/utils/dh-parallel",
    author="Boris Wiegand",
    author_email="boris.wiegand@dillinger.biz",
    classifiers=[
        "Programming Language :: Python :: 3",
        "Programming Language :: Python :: 3.7",
        "Topic :: Utilities"
    ],
    packages=find_namespace_packages(exclude=["tests.*", "tests"]),
    include_package_data=True,
    exclude_package_data={
            "": ['*.pyc']
    },
    install_requires=install_reqs
)