# -*- coding: utf-8 -*-

from prolothar.pm.models.directly_follows_graph import DirectlyFollowsGraph

from typing import Set

class ConnectedSimplePrecedenceDiagram:
    """ implementation of the Definition 4.3 from 
    "Process Mining: Fuzzy CLustering and Performance Visualization" by van 
    Dongen and Adriansyah
    """
    def __init__(self):
        self.__dfg = DirectlyFollowsGraph()
        
    def add_node(self, activity_set: Set[str]):
        """adds a node represented by the given activity set to the graph"""
        self.__dfg.add_node(str(activity_set))
        
    def plot(self, filepath: str=None, view: bool=True, filetype: str='pdf'):
        """plots this graph and returns the graph viz dot source code"""
        return self.__dfg.plot(filepath=filepath, view=view, filetype=filetype,
                               show_counts=False)
        
    def get_nr_of_edges(self) -> int:
        """returns the number of edges in this cspd"""
        return self.__dfg.get_nr_of_edges()
        
    def get_nr_of_nodes(self) -> int:
        """returns the number of nodes in this cspd"""
        return self.__dfg.get_nr_of_nodes()
    
    def add_edge(self, activity_set_a: Set[str], activity_set_b: Set[str]):
        self.__dfg.add_count(str(activity_set_a), str(activity_set_b))
