# -*- coding: utf-8 -*-
import os
import pathlib
import io
from zipfile import ZipFile

from prolothar_common.models.dataset import TargetSequenceDataset

HERE = pathlib.Path(__file__).parent

def load_dataset() -> TargetSequenceDataset:
    with ZipFile(os.path.join(HERE, 'anonymized_rolling_mill.zip')) as zf:
        with io.TextIOWrapper(zf.open(next(iter(zf.namelist()))), encoding='utf-8') as f:
            return TargetSequenceDataset.create_from_arff(f.read(), 'sequence')
