# -*- coding: utf-8 -*-
import pathlib

from prolothar_common.models.dataset import MultiLabelDataset
from prolothar_common.models.dataset.instance import MultiLabelInstance

HERE = pathlib.Path(__file__).parent

def load_dataset() -> MultiLabelDataset:
    with open(HERE / '20ng.arff') as f:
        return MultiLabelDataset.create_from_arff(f.read(), [
            'comp.os_ms_windows_misc',
            'religion.rmisc',
            'rec.sport.baseball',
            'sci.space',
            'comp.sys.mac_hardware',
            'sci.med',
            'politics.pmisc',
            'rec.autos',
            'misc_forsale',
            'politics.mideast',
            'rec.motorcycles',
            'politics.guns',
            'rec.sport.hockey',
            'comp.sys.ibm_pc_hardware',
            'comp.graphics',
            'sci.crypt',
            'sci.electronics',
            'religion.christian',
            'religion.atheism',
            'comp.windows_x',
        ])
