# -*- coding: utf-8 -*-

import pathlib
import pandas as pd

from prolothar_common.models.eventlog import EventLog
from prolothar_common.models.directly_follows_graph import DirectlyFollowsGraph

HERE = pathlib.Path(__file__).parent

def load_log_for_experiments():
    log = pd.read_csv(str(HERE / 'OrdonezA_ADLs.txt'), sep=';',)

    log['Date'] = log['Start time'].str[:11]
    log['Start'] = pd.to_datetime(log['Start time'])
    log['End'] = pd.to_datetime(log['End time'])

    log = EventLog.create_from_pandas_df(
            log, 'Date', 'Activity',
            event_attribute_columns=['Start', 'End'],
            trace_attribute_columns=[])

    #there must be a start and an end event
    log.add_start_activity_to_every_trace('START')
    log.add_end_activity_to_every_trace('END')

    return log
