#ifndef CONST_H
#define CONST_H

#include <stdlib.h>

namespace CONST
{
    // Threshold for number of ones in data for the usage of sparse bitvecs
    // If the proportion of ones is less than threshold, use sparse DS
    constexpr double SPARSETHRESH = 0.01;

    // Epsilon for usg pruning
    constexpr uint32_t EPSUSG = 1;

    // epsilon for double comparisons
    constexpr double EPSDOUBLE = 0.00001;

    // Minimum overlap threshold for AND pattern
    // I.e. minimum percentage of overlap between tids of two patterns to be joined
    constexpr double MINOVERLAP = .8;

    // Maximum overlap threshold for XOR pattern
    // I.e. maximum percentage of overlap between two patterns to be joined
    constexpr double MAXOVERLAP = 1-MINOVERLAP;

    // Minimum number of transactions covered to be considered for XOR
    constexpr double MINCOVER = .001;

    // Minimum support threshold for pattern
    // (Percentage of number of rows to be covered)
    constexpr double MINSUP = .001;

    // P Value cutoff for XOR test
    constexpr double PCUTOFF = .001;

    #define CORENUM 1
}

#endif // CONST_H
