#ifndef MDLALGO_H
#define MDLALGO_H


#include "pattern.h"
#include "codestats.h"


namespace MDLAlgo
{



// Codelength of data under given pattern sending over nrow rows, returns the number of remaining uncovered rows
double dataCLPattern(const std::shared_ptr<Node>& n, const bool isRoot);
// Codelength of model
double modelCL(const std::vector<std::shared_ptr<Pattern> > patterns);
double modelCL(const std::list<std::shared_ptr<Pattern> > patterns);
// Model costs of a particular pattern
double modelCLPattern(const std::shared_ptr<Node>& n, const bool isRoot);

} // end namespace MDLAlgo

#endif // MDLALGO_H