/*
 * ChoicePattern.h
 *
 *  Created on: Nov 28, 2015
 *      Author: abhattac
 */

#ifndef CHOICEPATTERN_H_
#define CHOICEPATTERN_H_

#include <climits>
#include <cstdint>

#include "Pattern.h"
#include "Data.h"
#include "LabelList.h"

using namespace std;

class ChoicePattern {
public:
	ChoicePattern( Pattern* first_pattern, Data *D );
	virtual ~ChoicePattern();
	double get_codelen( Data *D );
	void add_pattern( Pattern *new_pattern, Data *D );
	double change_in_codelen_if_added( Pattern *new_pattern, Data *D );
	bool pattern_can_be_added( Pattern *new_pattern );
	void print();
	void print(LabelList &label_list);
	int index_of_sub_pattern( Pattern *query_pattern );
	void delete_sub_pattern( uint32_t idx, Data *D );
	int get_num_of_sub_patterns();
	Pattern* get_sub_pattern( uint32_t idx );

private:
	vector<Pattern*> sub_patterns;
	int32_t point_of_diff;
	double codelen = INT_MAX;
};



#endif /* CHOICEPATTERN_H_ */
