/*
 * Pattern.h
 *
 *  Created on: Mar 10, 2015
 *      Author: abhattac
 */

#ifndef SQS_PATTERN_H_
#define SQS_PATTERN_H_
#include <string>
#include "UnBoundedArray.h"
#include <vector>
#include <cstdint>

class Pattern {
public:

private:
	std::vector<int32_t> p;
	uint32_t size;
	uint32_t usage;
	uint32_t gaps;
	uint32_t num;
	double stlen;
	std::vector<int32_t> hist;
	uint32_t hist_size = 0;
	uint32_t max_gap_len;
	double pattern_code_length;
	double preq_gap_code_length;
	double preq_fill_code_length;
	double gain_in_code_len = 0;
	uint32_t merge_pos;
	uint32_t sort_index = 0;
	uint32_t stops = 0;

public:
	Pattern(std::vector<int> &p);
	Pattern(std::vector<int> &p, int merge_pos);
	~Pattern();
	int32_t charAt(int i) const;
	int32_t charAt(uint32_t i) const;
	uint32_t getSize() const;
	void setPatternNum(int32_t num);
	void setUsage(int32_t usage);
	void setGaps(int32_t gaps);
	void setPatternCodeLength(double len);
	void setPatternStLength(double len);
	uint32_t getUsage() const ;
	uint32_t getGaps() const;
	double getPatternCodeLength() const;
	double getGapCodeLength() const;
	double getFillCodeLength() const;
	double getPatternStLength() const;
	void update_hist(int32_t gap_len);
	void reset_hist();
	double getGapCodeLength(int32_t gap_size) const;
	double getMaxGap() const;
	uint32_t getPatternNum() const;
	void printPattern();

	double getPreqGapCodeLength() const;
	double getPreqFillCodeLength() const;

	double getGainInCodeLength() const;
	double setGainInCodeLength( double gain );

	void setPreqGapCodeLength(double pgcl);
	void setPreqFillCodeLength(double pfcl);
	uint32_t getMergePos() const;

	uint32_t getSortIndex() const;
	void setSortIndex(int32_t index);

	void setStops( uint32_t stops );
	uint32_t getStops();
};

#endif /* SQS_PATTERN_H_ */
