/*
 * UnBoundedArray.h
 *
 *  Created on: Mar 10, 2015
 *      Author: abhattac
 */

#ifndef SQS_UNBOUNDEDARRAY_H_
#define SQS_UNBOUNDEDARRAY_H_
#include <new>
#include <iostream>
using namespace std;

template <class T>
class UnBoundedArray {
	int size;
	int len;
	T *data;
	int alpha;
	int beta;
public:
	UnBoundedArray();
	virtual ~UnBoundedArray();
	void insert(T x);
	T at(int i);
	T insertAt(int i,T x);
	int getSize();
};

template <class T>
UnBoundedArray<T>::UnBoundedArray() {
	// TODO Auto-generated constructor stub
	size = 0;
	data = new T[1];
	alpha = 4;
	beta = 2;
	len = 1;
}

template <class T>
void UnBoundedArray<T>::insert(T x) {
	if(size == len)
	{
		T *tdata = new (nothrow) T[beta*(len)];
		len = beta*(len);
		//cout << len << endl;
		if (tdata == nullptr)
		{
			cout << "Error: memory could not be allocated";
		}
		else
		{
			for(int i=0;i<size;i++)
			{
				tdata[i] = data[i];
			}
			delete[] data;
			data = tdata;
		}
	}
	data[size++] = x;
}

template <class T>
T UnBoundedArray<T>::at(int x) {
	if(x<size)
	{
		return data[x];
	}
	else
	{
		return 0;
	}
}

template <class T>
T UnBoundedArray<T>::insertAt(int i, T x) {
	if(i<size)
	{
		data[i] = x;
	}
	else
	{
		cout << "Index out of range: " << i << endl;
	}
	return 0;
}

template <class T>
int UnBoundedArray<T>::getSize() {
	// TODO Auto-generated destructor stub
	return size;
}

template <class T>
UnBoundedArray<T>::~UnBoundedArray() {
	// TODO Auto-generated destructor stub
	delete[] data;
}

#endif /* SQS_UNBOUNDEDARRAY_H_ */
