/*
 * common_functions.h
 *
 *  Created on: Sep 22, 2015
 *      Author: abhattac
 */

#ifndef COMMON_FUNCTIONS_H_
#define COMMON_FUNCTIONS_H_

#include <vector>
#include "../misc/Pattern.h"
#include "../misc/Mwindow.h"
#include "../misc/Data.h"
#include "../misc/ChoicePattern.h"
#include "../misc/LabelList.h"
#include <cstdint>

bool vec_and( vector<bool> &v );
void print_all_patterns( std::vector<Pattern*> P );
void delete_list(Mwindow *start);
double gain(Mwindow *w, Data *D);
double gain_preq(Mwindow *w, Data *D);
double new_gain(Mwindow *w, Data *D);
int length_list(Mwindow *allwin_start);
void print_all_mwindow_patterns(Mwindow *start);
int max_pattern_num(vector<Pattern*> &list_of_patterns);
bool check_if_pattern_num_exists_twice(vector<Pattern*> &list_of_patterns, int pat_num);
void pat_num_check( vector<Pattern*> &list_of_patterns );
double approx_prequential_length_of_binary_sequence( uint32_t f1, uint32_t f2 );
double exact_prequential_length_of_binary_sequence( int fills, int gaps, double epsilon );
double optimal_length_of_binary_sequence( uint32_t f1, uint32_t f2  );
void delete_mwindows_in_vector( vector<Mwindow*> &mwindow_list );
uint32_t max(uint32_t a, uint32_t b);

void print_alignment( vector<Mwindow*> &alignment, uint32_t len );
double exact_prequential_length_of_trinary_sequence( int fills, int gaps, int stops, double epsilon );


void build_list_of_choice_patterns( vector<Pattern*> &list_of_patterns, vector<ChoicePattern> &list_of_choice_patterns, Data *D );
int32_t check_if_new_pattern_can_be_made_a_choice_pattern( Pattern *new_pattern, vector<ChoicePattern> &list_of_choice_patterns, Data *D );
void print_all_choice_patterns( vector<ChoicePattern> &list_of_choice_patterns, Data *D );
void print_all_choice_patterns_with_labels( vector<ChoicePattern> &list_of_choice_patterns, Data *D, LabelList &label_list );

#endif /* COMMON_FUNCTIONS_H_ */
