/*
 * new_search.cpp
 *
 *  Created on: Nov 26, 2015
 *      Author: abhattac
 */

#include <iostream>
#include <stdio.h>
#include <queue>
#include <string.h>
#include "../misc/EncodingCalucator.h"
#include <math.h>
#include <vector>
#include <algorithm>
#include "../sqs/sqs.h"
#include <climits>
#include "../misc/Mwindow.h"
#include "../ditto/encode.h"
#include "../misc/Data.h"
#include "../misc/ChoicePattern.h"
#include "../misc/common_functions.h"
#include "../misc/LabelList.h"
#include <cstdint>
#include <unordered_map>
#include <omp.h>
#include "../misc/post_process.h"
#include "find_win_pq.h"

using namespace std;

typedef int32_t int32;
typedef uint32_t uint32;

/*class t {
public:
	int v_idx = 0;
	int next_idx = 0;
	int d = 0;
	double s = 0;
	int l = 0;
	bool *counted_X = nullptr;

	t(int v_idx, int next_idx, double d, double s, int l, int num_of_patterns, int num_X) {
		this->v_idx = v_idx;
		this->next_idx = next_idx;
		this->d = d;
		this->s = s;
		this->l = l;
		counted_X = new bool[num_of_patterns + 1];
		memset(counted_X, false, (num_of_patterns + 1) * sizeof(bool) );
		counted_X[ num_X ] = true;
	}
};*/

class t {
public:
	uint32 alignment_idx = 0;
	int32 next_alignment_idx = 0;
	int32 d = 0;
	double s = 0;
	int32 l = 0;
	//vector<bool> counted_X;
	bool *counted_X;
	uint32 num_of_patterns = 0;

	t(uint32 current_alignment_idx, int32 next_alignment_idx, int32 d, double s, int32 l, uint32 num_of_patterns ) {
		this->alignment_idx = current_alignment_idx;
		this->next_alignment_idx = next_alignment_idx;
		this->d = d;
		this->s = s;
		this->l = l;
		this->num_of_patterns = num_of_patterns;
		this->counted_X = new bool[ num_of_patterns ];
		/*for(int i = 0; i < num_of_patterns; i++)
		{
			counted_X.push_back(false);
		}*/
		for(uint32 i = 0; i < num_of_patterns; i++)
		{
			counted_X[i] = false;
		}
	}

	void count_X( uint32 i )
	{
		counted_X[i] = true;
	}

	t(const t &obj)
	{
		this->alignment_idx = obj.alignment_idx;
		this->next_alignment_idx = obj.next_alignment_idx;
		this->d = obj.d;
		this->s = obj.s;
		this->l = obj.l;
		this->num_of_patterns = obj.num_of_patterns;
		/*for(int i = 0; i < num_of_patterns; i++)
		{
			counted_X.push_back( obj.counted_X[i] );
		}*/
		this->counted_X = new bool[obj.num_of_patterns];
		for(uint32 i = 0; i < num_of_patterns; i++)
		{
			this->counted_X[i] = obj.counted_X[i];
		}
	}

	~t()
	{
		//counted_X.clear();
		delete[] counted_X;
	}

};

class Encoding {
public:

	vector<int> susages;

	double lctc = 0;
	double ldct = 0;
	//int num_of_used_patterns = 0;
	int pattern_stream_length = 0;
	int num_of_used_patterns = 0;
	int sum_of_pattern_usages = 0;
	int num_of_used_chars = 0;


	Encoding(Mwindow *alignedwin, Data *D, vector<Pattern*> &list_of_patterns) {

		//cout << "Encoding constructor begin" << endl;

		for(uint32 i = 0; i < D->getMaxAlphaNum(); i++)
		{
			susages.push_back( D->getAlphabetSupport(i) );
		}


		Mwindow *alignedwin_tmp = alignedwin;

		for(uint32 i = 0; alignedwin_tmp != nullptr; i++, alignedwin_tmp = alignedwin_tmp->next )
		{

			if( alignedwin_tmp->pattern->getSize() > 1 )
			{
				for(uint32 j = 0; j < alignedwin_tmp->pattern->getSize(); j++)
				{
					if( alignedwin_tmp->getPositionInData(j) > D->getSize() )
					{
						cout << "Pos greater than length: Pat num: " << alignedwin_tmp->pattern->getPatternNum() << " win start:"
								<< alignedwin_tmp->getStartIndex() << " - win end: " << alignedwin_tmp->getEndIndex()
								<< " - P size: " << alignedwin_tmp->pattern->getSize() << " j: " << j << endl;
						exit(0);
					}
					susages[ D->charAt( alignedwin_tmp->getPositionInData(j) ) ]--;
				}
			}

		}

		for(uint32 i = 0; i < susages.size(); i++ )
		{
			pattern_stream_length += susages[i];
			if( susages[i] > 0 )
			{
				num_of_used_chars++;
			}
		}
		for(uint32 i = 0; i < list_of_patterns.size(); i++)
		{
			if( list_of_patterns[i]->getSize() > 1 )
			{
				pattern_stream_length += list_of_patterns[i]->getUsage();
				sum_of_pattern_usages += list_of_patterns[i]->getUsage();
				if( list_of_patterns[i]->getUsage() > 0 )
				{
					num_of_used_patterns++;
				}
			}
		}

		//cout << "Encoding constructor end" << endl;
	}

	Encoding( vector<Mwindow*> &selected_win, Data *D, vector<Pattern*> &list_of_patterns) {

		//cout << "Encoding constructor begin" << endl;

		uint32 sum_suages = 0;
		for(uint32 i = 0; i <= D->getMaxAlphaNum(); i++)
		{
			susages.push_back( D->getAlphabetSupport(i) );
		}


		for(uint32 i = 0; i < selected_win.size(); i++ )
		{
			if( selected_win[i]->pattern->getSize() > 1 )
			{
				for(uint32 j = 0; j < selected_win[i]->getUsedLen(); j++)
				{
					susages[ D->charAt( selected_win[i]->getPositionInData(j) ) ]--;
				}
			}

		}
		for(uint32 i = 0; i < susages.size(); i++ )
		{
			pattern_stream_length += susages[i];
			if( susages[i] > 0 )
			{
				num_of_used_chars++;
			}
		}
		for(uint32 i = 0; i < list_of_patterns.size(); i++)
		{
			if( list_of_patterns[i]->getSize() > 1 )
			{
				pattern_stream_length += list_of_patterns[i]->getUsage();
				sum_of_pattern_usages += list_of_patterns[i]->getUsage();
				if( list_of_patterns[i]->getUsage() > 0 )
				{
					num_of_used_patterns++;
				}
			}
		}

		/*cout << "pattern stream length: " << pattern_stream_length << endl;
		cout << "sum of susages: " << sum_suages << endl;
		cout << "sum of pattern usages: " << sum_of_pattern_usages << endl;
		cout << "Encoding constructor end" << endl;
		exit(0);*/
	}

	double cal_code_length(Data *D, vector<Pattern*> &list_of_patterns )
	{
		lctc = 0;
		ldct = 0;
		EncodingCalucator ec;



		/*for(uint32 i = 0; i < susages.size(); i++)
		{
			cout << "char: " << i << " usage: " << susages[i] << endl;
		}*/

		for(uint32 i = 0; i < list_of_patterns.size(); i++)
		{

			if( list_of_patterns[i]->getUsage() > 0 && list_of_patterns[i]->getSize() > 1 )
			{

				lctc += ec.ln( list_of_patterns[i]->getSize() );
				for(uint32 j = 0; j < list_of_patterns[i]->getSize(); j++ )
				{
					lctc += ec.lu( (double)D->getSize() / D->getAlphabetSupport( list_of_patterns[i]->charAt(j) ) );
				}
			}

		}

		lctc += ec.ln( D->getMaxAlphaNum() + 1 ) + ec.approxlogchoose(D->getSize() - 1, D->getMaxAlphaNum() ) + ec.ln( num_of_used_patterns + 1 );
		lctc += ec.ln( sum_of_pattern_usages + 1 ) + ec.approxlogchoose( sum_of_pattern_usages - 1, num_of_used_patterns - 1) ;

		ldct = ec.ln( D->getSize() ) + ec.ln(1) ;

		for(uint32 i = 0; i <= D->getMaxAlphaNum(); i++ )
		{
			if( susages[i] > 0 )
			{
				ldct += susages[i] * ec.lu( (double) pattern_stream_length / susages[i] );
			}
		}

		for(uint32 i = 0; i < list_of_patterns.size(); i++)
		{
			if( list_of_patterns[i]->getUsage() > 0 && list_of_patterns[i]->getSize() > 1 )
			{
				ldct += list_of_patterns[i]->getUsage() * ec.lu((double)pattern_stream_length / list_of_patterns[i]->getUsage());
				int fills = list_of_patterns[i]->getUsage() * ( list_of_patterns[i]->getSize() -1 );
				int gaps = list_of_patterns[i]->getGaps();

				double pcl = exact_prequential_length_of_binary_sequence( fills, gaps, 0.5 );

				ldct += pcl;
			}
		}
		//cout << "Calc code len: " << (ldct + lctc) << endl;
		//exit(0);
		return ldct + lctc;
	}

	double diff(Pattern *P, const Pattern *X, int32 num_PX, int32 gaps_PX, int32 gaps_P, int32 gaps_X )
	{

		EncodingCalucator ec;

		//exit(0);*/
		/*if( gaps_PX > 0 )
		{
			cout << "Gaps of PX" << endl;
			exit(0);
		}*/
		int new_pattern_stream_length = pattern_stream_length - num_PX ;
		double nldct = ldct;
		/*if( P->getSize() == 1 && X->getSize() > 1 )
		{
			cout << " ---------------------------------- " << endl;
			cout << P->getUsage() << " - " << X->getUsage() << " - " << num_PX << " - " << gaps_PX << " - " << gaps_P << " - " << gaps_X << endl;
			cout << "Old pattern st: " << pattern_stream_length << " - New pattern st: " << new_pattern_stream_length << endl;
		}*/
		//cout << "Old data cost: " << nldct << endl;

		if( P->getUsage() > 0 )
			nldct -= P->getUsage() * ec.lu( (double) pattern_stream_length / P->getUsage() );

		if( X->getUsage() > 0 )
			nldct -= X->getUsage() * ec.lu( (double) pattern_stream_length / X->getUsage() );


		//cout << "ldct 2: " << nldct << endl;

		if( ((int32)P->getUsage() - num_PX) > 0)
		{
			nldct += (P->getUsage() - num_PX) * ec.lu( (double) pattern_stream_length / (P->getUsage() - num_PX) );
		}

		if( ((int32)X->getUsage() - num_PX) > 0)
		{
			nldct += (X->getUsage() - num_PX) * ec.lu( (double) pattern_stream_length / (X->getUsage() - num_PX) );
		}

		//cout <<  "ldct 3: " << nldct << endl;
		if( num_PX > 0 )
		{
			nldct += num_PX * ec.lu( (double) pattern_stream_length / num_PX );
		}
		//cout << "ldct 3.5: " << nldct << endl;
		nldct += ((double) new_pattern_stream_length) * ( log2( (double) new_pattern_stream_length ) - log2( (double) pattern_stream_length ) );
		//cout << "ldct 4: " << nldct << endl;
		if( P->getUsage() > 0 && P->getSize() > 1 )
		{
			int fills = P->getUsage() * ( P->getSize() -1 );
			int gaps = P->getGaps();
			nldct -= exact_prequential_length_of_binary_sequence( fills, gaps, 0.5 );
			//nldct -= approx_prequential_length_of_binary_sequence( fills, gaps  );
		}
		//cout << "ldct 5: " << nldct << endl;

		if( X->getUsage() > 0 && X->getSize() > 1 )
		{
			int fills = X->getUsage() * ( X->getSize() -1 );
			int gaps = X->getGaps();
			nldct -= exact_prequential_length_of_binary_sequence( fills, gaps, 0.5 );
			//nldct -= approx_prequential_length_of_binary_sequence( fills, gaps  );
		}

		if( P->getSize() > 1 && ((int32)P->getUsage() - num_PX) > 0 )
		{
			int fills = (P->getUsage() - num_PX) * ( P->getSize() -1 );
			int gaps = (P->getGaps() - gaps_P);
			nldct += exact_prequential_length_of_binary_sequence( fills, gaps, 0.5 );
			//nldct += approx_prequential_length_of_binary_sequence( fills, gaps  );
		}

		if( X->getSize() > 1 && (int32)(X->getUsage() - num_PX) > 0 )
		{
			int fills = (X->getUsage() - num_PX) * ( X->getSize() -1 );
			int gaps = (X->getGaps() - gaps_X);
			nldct += exact_prequential_length_of_binary_sequence( fills, gaps, 0.5 );
			//nldct += approx_prequential_length_of_binary_sequence( fills, gaps );
		}

		if( num_PX > 0 )
		{
			int fills = num_PX * ( P->getSize() + X->getSize() -1 );
			int gaps = gaps_PX;
			nldct += exact_prequential_length_of_binary_sequence( fills, gaps, 0.5 );
			//nldct += approx_prequential_length_of_binary_sequence( fills, gaps );
		}
		//cout << "ldct 6: " << nldct << endl;
		uint32 new_num_of_used_patterns = num_of_used_patterns, new_sum_of_pattern_usages = sum_of_pattern_usages;

		if( P->getSize() > 1 && ((int32)P->getUsage() - num_PX) == 0 )
		{
			new_num_of_used_patterns--;
		}

		if( X->getSize() > 1 && ((int32)X->getUsage() - num_PX) == 0 )
		{
			new_num_of_used_patterns--;
		}

		if( P->getSize() == 1 || X->getSize() == 1 )
		{
			new_num_of_used_patterns++;
			new_sum_of_pattern_usages += num_PX;
		}
		else
		{
			new_sum_of_pattern_usages -= num_PX;
		}
		/*if( nldct > 200000 )
		{
			cout << "nldct: " << nldct << endl;
			cout << gaps_X << " -- " << gaps_P << " -- " << gaps_X << endl;
			//exit(0);
		}*/
		//cout << "New data cost: " << nldct << endl;
		//cout << "Old model cost: " << lctc << endl;
		double nlctd = lctc - ec.ln( num_of_used_patterns + 1 ) + ec.ln( new_num_of_used_patterns + 1 );
		if( X->getSize() > 1 && P->getSize() > 1 )
		{
			nlctd = nlctd - ec.ln( sum_of_pattern_usages + 1 ) + ec.ln( new_sum_of_pattern_usages + 1 );
			nlctd = nlctd - ec.approxlogchoose( sum_of_pattern_usages - 1, num_of_used_patterns -1 ) + ec.approxlogchoose( new_sum_of_pattern_usages - 1, new_num_of_used_patterns -1 );
		}
		//cout << "New model cost: " << nlctd << endl;
		//cout << "Old num of used patterns: " << num_of_used_patterns << " - New num of used patterns: " << new_num_of_used_patterns << endl;
		//cout << "Old sum of pattern usages: " << sum_of_pattern_usages << " - New sum of pattern usages: " << new_sum_of_pattern_usages << endl;
		/*if( P->getSize() == 1 && X->getSize() > 1 )
		{
			cout << " ---------------------------------- " << endl;
			cout << "P: " ;
			P->printPattern();
			cout << " Q: " ;
			X->printPattern();
			cout << "Num Px: " << num_PX << " est gain: " << - ( lctc + ldct - nlctd - nldct ) << endl;
			cout << " ---------------------------------- " << endl;
		}*/
		return -( lctc + ldct - nlctd - nldct );
	}

	double gain(Mwindow *w, Data *D)
	{

		const Pattern *p = w->pattern;
		double lx = 0;

		for(uint32 i=0; i<w->pattern->getSize(); i++)
		{
			lx += log2((double)D->getSize()/D->getAlphabetSupport( p->charAt(i) ));
		}
		if( w->getNumOfGaps() > w->pattern->getSize() )
		{
			return (-( w->pattern->getPatternCodeLength() )
					-( w->getEndIndex() - w->getStartIndex() - w->pattern->getSize() + 1) * 1
					-( w->pattern->getSize() - 1) * 1 + lx );
		}
		return (-(w->pattern->getPatternCodeLength())
				- (w->getEndIndex() - w->getStartIndex() - w->pattern->getSize() + 1)*(w->pattern->getGapCodeLength())
				- ( w->pattern->getSize() - 1)*(w->pattern->getFillCodeLength()) + lx);
	}

};

struct tcomparator {
	bool operator() ( t *i, t *j){
		return i->l < j->l;
	}
};


void find_windows( Pattern *X, const Data *D, vector<Mwindow*> &curr_mwindows)
{

	for(uint32 i = 0; i < D->getSize(); i++)
	{
		if( D->charAt(i) == X->charAt(0) )
		{

			Mwindow *tmw;
			vector<uint32> pos;

			pos.push_back( i );
			uint32 j = i + 1, k = 1;
			bool flag = true;
			uint32 gapcount = 0;
			while( flag && j < D->getSize() && gapcount <= X->getSize() + 1 )
			{
				//cout << j << " " << k << " " << x[k] << endl;
				//cout << " .. char: " << D->charAt(j) << endl;
				if( X->charAt(k) == D->charAt(j))
				{
					//cout << " .. char found: " << D->charAt(j) << endl;
					pos.push_back( j );
					k++;
				}
				else if( D->charAt(j) == -1 )
				{
					break;
				}
				else
				{
					gapcount++;
				}
				if(k == X->getSize())
				{
					flag = false;
					//cout << "Found!" << endl;
					tmw = new Mwindow(i, j, X, 0, pos, gapcount, X->getSize());
					//i = j;
				}
				j++;
			}
			//cout << " Search terminated .." << endl;
			if( !flag )
			{

				curr_mwindows.push_back( tmw );
			}

			pos.clear();
		}
	}
}

int count_all_gaps(vector<Mwindow*> &curr_mwindows)
{
	int gaps = 0;
	for(uint32 i = 0; i < curr_mwindows.size(); i++ )
	{
		gaps += curr_mwindows[i]->getNumOfGaps();
	}
	return gaps;
}

void append_mwindows_of_new_pattern( Data *D, vector<vector<Mwindow*>> &list_of_mwindows, Pattern *new_pattern)
{
	vector<Mwindow*> tmp_mwindows;
	find_win_pq( D, new_pattern, tmp_mwindows);
	//find_windows( new_pattern, D, tmp_mwindows);

	list_of_mwindows.push_back( tmp_mwindows );
	/*cout << "Pattern size: " << new_pattern->getSize() << endl;
	cout << "tmp_windows size: " << tmp_mwindows.size() << endl;
	cout << "Total gaps: " << count_all_gaps( tmp_mwindows ) << endl;*/
	int usage = tmp_mwindows.size();

	new_pattern->setUsage( usage );
	new_pattern->setGaps( usage * ( new_pattern->getSize() -1) );
	new_pattern->setPatternCodeLength( log2( (double) D->getSize() / usage) );

	int fills = new_pattern->getUsage() * ( new_pattern->getSize() -1 );
	int gaps = new_pattern->getGaps();
	new_pattern->setPreqFillCodeLength( log2( (double) ( 1 + fills + gaps ) / (0.5 + fills) )  );
	new_pattern->setPreqGapCodeLength( log2( (double) ( 1 + fills + gaps ) / (0.5 + gaps) )  );
}





double min(double a, double b)
{
	if(a < b)
	{
		return a;
	}
	return b;
}

struct t_index_len_container
{
    uint32 index = 0;
    uint32 len = 0;
    bool operator<(const t_index_len_container& rhs) const
    {
        return len > rhs.len;
    }
};

void init_priority_queue_T( vector<Mwindow*> &alignment, vector<t*> &t_list, priority_queue<t_index_len_container> &T,
		Pattern *P, uint32 total_num_of_patterns )
{
	uint32 tcont_idx = 0;
	for(uint32 win_idx = 0; win_idx < alignment.size() ; win_idx++)
	{
		if( alignment[ win_idx ]->pattern->charAt(0) != -1 )
		{
			if( alignment[ win_idx ]->getUsedLen() == P->getSize() && alignment[ win_idx ]->pattern->getPatternNum() == P->getPatternNum() )
			{
				if( win_idx < alignment.size() - 1
				    && alignment[ win_idx + 1 ]->getUsedLen() == alignment[ win_idx + 1 ]->pattern->getSize()
					&& alignment[ win_idx + 1 ]->pattern->charAt(0) != -1 )
				{
					int next_win_j = alignment[ win_idx + 1 ]->getEndIndex();
					t *ttmp = new  t( win_idx, win_idx + 1, next_win_j, 0, next_win_j - alignment[ win_idx ]->getStartIndex(), total_num_of_patterns );
					ttmp->count_X( alignment[ win_idx + 1 ]->pattern->getPatternNum() );
					t_list.push_back( ttmp );
					t_index_len_container tcont_tmp;
					tcont_tmp.index =  tcont_idx++;
					tcont_tmp.len = ttmp->l ;
					T.push( tcont_tmp );

				}
				else // problem? (should this case exist?)
				{
					t *ttmp =new  t( win_idx, -1, alignment[ win_idx ]->getEndIndex(), 0, alignment[ win_idx ]->getEndIndex() - alignment[ win_idx ]->getStartIndex(), total_num_of_patterns );
					t_list.push_back( ttmp );
					t_index_len_container tcont_tmp;
					tcont_tmp.index =  tcont_idx++;
					tcont_tmp.len = ttmp->l ;
					T.push( tcont_tmp );
				}
			}
		}
	}
}

void delete_t_vec( vector<t*> &t_list )
{
	for(uint32 i = 0; i < t_list.size(); i++ )
	{
		delete (t_list[i]);
	}
}



std::pair <int,double> estimate(Pattern *P, vector<Pattern*> &list_of_patterns, vector<Mwindow*> &alignment, Data *D, Encoding &ed)
{
	//cout << "P p[0]" << P->p[0] << endl;

	//priority_queue<t*, vector<t*>, tcomparator> *T = new priority_queue<t*, vector<t*>, tcomparator>;

	vector<t*> t_list;

	priority_queue<t_index_len_container> T;
	#pragma omp critical
	{
		init_priority_queue_T( alignment, t_list, T, P, list_of_patterns.size()  );
	}
	//cout << "Estimate !" << endl;
	int32 num_win = alignment.size();

	vector<bool> mark ( num_win + 1, false);

	vector<double> dx ( list_of_patterns.size() + 1, 0);

	vector<int32> gaps_PX ( list_of_patterns.size() + 1, 0);
	vector<int32> gaps_P ( list_of_patterns.size() + 1, 0);
	vector<int32> gaps_X ( list_of_patterns.size() + 1, 0);
	vector<int32> num_PX ( list_of_patterns.size() + 1, 0);


	while( !T.empty() )
	{

		t_index_len_container tcont_tmp = T.top();
		t *ttmp = t_list[ tcont_tmp.index ];
		T.pop();

		if( ttmp->next_alignment_idx == -1 )
		{
			continue;
		}

		Mwindow *v = alignment[ ttmp->alignment_idx ];
		Mwindow *w = alignment[ ttmp->next_alignment_idx ];

		if( w->pattern->getPatternNum() == P->getPatternNum() && ( mark[ ttmp->alignment_idx ] || mark[ ttmp->next_alignment_idx ] ))
		{
			//cout << "In here" << endl;
			//delete ttmp;
			continue;
		}
		if( true )
		{
			num_PX[ w->pattern->getPatternNum() ]++;
			gaps_PX[ w->pattern->getPatternNum() ] += (w->getEndIndex() - v->getStartIndex()
					- w->pattern->getSize() - v->pattern->getSize() + 1);
			gaps_P[ w->pattern->getPatternNum() ] += v->getNumOfGaps();
			gaps_X[ w->pattern->getPatternNum() ] += w->getNumOfGaps();
			double ddtmp = ed.diff(P, w->pattern, num_PX[ w->pattern->getPatternNum() ], gaps_PX[ w->pattern->getPatternNum() ], gaps_P[ w->pattern->getPatternNum() ], gaps_X[ w->pattern->getPatternNum() ] );
			double tsgain = gain_preq(w, D);
			//cout << "ddtmp: " << ddtmp << endl;
			dx[ w->pattern->getPatternNum() ] = min( ddtmp + ttmp->s, dx[ w->pattern->getPatternNum() ] );
			//cout << dx[ w->X->num ] << endl;
			if( w->pattern->getSize() > 1 )
			{
				ttmp->s = ttmp->s + tsgain;
			}
			if( w->pattern->getPatternNum() == P->getPatternNum() )
			{
				mark[ ttmp->alignment_idx ] = true;
				mark[ ttmp->next_alignment_idx ] = true;
				//delete ttmp;
				//cout << "In here 1" << endl;
				continue;
			}
		}

		if( ttmp->next_alignment_idx + 1 >= num_win  )
		{
			//delete ttmp;
			//cout << "In here 2" << endl;
			continue;
		}
		else
		{
			/*cout << "Pattern num: " << alignment[ ttmp->next_alignment_idx + 1 ]->pattern->getPatternNum() << endl;
			cout << "Number of patterns: " << list_of_patterns.size() << endl;*/
			while(true)
			{
				if( ttmp->next_alignment_idx + 1 >= num_win || alignment[ ttmp->next_alignment_idx + 1 ]->pattern->charAt(0) == -1 )
				{
					//delete ttmp;
					break;
				}
				if( !ttmp->counted_X[ alignment[ ttmp->next_alignment_idx + 1 ]->pattern->getPatternNum() ]
					&& alignment[ttmp->next_alignment_idx + 1 ]->getUsedLen() == alignment[ ttmp->next_alignment_idx + 1 ]->pattern->getSize() )
				{
					ttmp->d = alignment[ ttmp->next_alignment_idx + 1 ]->getEndIndex();
					if( alignment[ ttmp->next_alignment_idx + 1 ]->pattern->getPatternNum()
							!=  alignment[ ttmp->alignment_idx ]->pattern->getPatternNum() )
					{
						ttmp->count_X( alignment[ ttmp->next_alignment_idx + 1 ]->pattern->getPatternNum() );
					}
					ttmp->l = ttmp->d - alignment[ ttmp->alignment_idx ]->getStartIndex();

					uint32 size_of_p = alignment[ ttmp->alignment_idx ]->pattern->getSize();
					uint32 size_of_x = alignment[ ttmp->next_alignment_idx + 1 ]->pattern->getSize();

					ttmp->next_alignment_idx = ttmp->next_alignment_idx + 1;

					//cout << "Length: " << ttmp->l  << endl;

					/*if( ttmp->l > 5000 )
					{
						alignment[ ttmp->alignment_idx ]->pattern->printPattern();
						cout << "Error" << endl;
						//exit(0);
					}*/

					if( ttmp->l - size_of_p - size_of_x > ( size_of_p + size_of_x + 1) )
					{
						break;
					}
					else
					{
						tcont_tmp.len = ttmp->l;
						T.push( tcont_tmp );
						break;
					}
				}
				else
				{
					ttmp->next_alignment_idx = ttmp->next_alignment_idx + 1;
				}
			}
		}

	}
	#pragma omp critical
	{
		delete_t_vec( t_list );
	}

	//cout << "Estimate end" << endl;
	int mini = 0;
	double min = 0;
	for(uint32 i = 0; i < list_of_patterns.size() + 1; i ++)
	{
		//cout << "Estimated gain: " << dx[i] << endl;
		if( dx[i] < min )
		{
			min = dx[i];
			mini = i;
		}
	}

	std::pair <int,double> pair_min_gain;
	pair_min_gain = std::make_pair(mini, min);

	/*mark.clear();
	dx.clear();
	gaps_PX.clear();
	gaps_P.clear();
	gaps_X.clear();
	num_PX.clear();*/
	//delete tmp;
	/*unsigned static int iterc = 0; iterc++;
	if( iterc > 10000 )
	{*/
	//}
	return pair_min_gain;
}


bool ct_diff(vector<Pattern*> &list_of_patterns, Pattern *X, Data *D, double g)
{
	int sum_of_usages = 0, num_of_used_patterns = 0;
	for(uint32 i = 0; i < list_of_patterns.size(); i++)
	{
		sum_of_usages += list_of_patterns[i]->getUsage();
		if( list_of_patterns[i]->getUsage() > 0 )
		{
			num_of_used_patterns ++;
		}
	}

	EncodingCalucator ec;

	double len_ct = ec.ln( list_of_patterns.size() ) + ec.ln( sum_of_usages ) + ec.approxlogchoose( sum_of_usages, list_of_patterns.size());

	double len_nct = ec.ln( list_of_patterns.size() - 1 ) + ec.ln( sum_of_usages - X->getUsage() ) + ec.approxlogchoose( sum_of_usages - X->getUsage() - 1, list_of_patterns.size() - 2 );

	for(uint32 i = 0; i < list_of_patterns.size(); i++)
	{
		len_ct += ec.ln( list_of_patterns[i]->getSize() ) + ec.ln( list_of_patterns[i]->getGaps() );
		if( X->getPatternNum() == list_of_patterns[i]->getPatternNum() )
		{
			for(uint32 j = 0; j < list_of_patterns[i]->getSize(); j++)
			{
				//Pattern *ppp = list_of_patterns[j];
				len_ct += ec.lu( (double) D->getSize() / D->getAlphabetSupport( list_of_patterns[i]->charAt(j) ) );
			}
		}
		else
		{
			len_nct += ec.ln( list_of_patterns[i]->getSize() ) + ec.ln( list_of_patterns[i]->getGaps() );
			for(uint32 j = 0; j < list_of_patterns[i]->getSize(); j++)
			{
				len_ct += ec.lu( (double) D->getSize() / D->getAlphabetSupport( list_of_patterns[i]->charAt(j) ) );
				len_nct += ec.lu( (double) D->getSize() / D->getAlphabetSupport( list_of_patterns[i]->charAt(j) ) );
			}
		}

	}

	return (g < (len_ct - len_nct));

}

void get_allwin_and_init_pattern_usages(vector<Pattern*> &PUX, vector<vector<Mwindow*>> &list_of_mwindows, Data *D )
{
	list_of_mwindows.clear();
	for(uint32 pattern_index = 0; pattern_index < PUX.size(); pattern_index++)
	{
		PUX[pattern_index]->setPatternNum( pattern_index );
		vector<Mwindow*> tmp_mwindows;
		find_windows( PUX[pattern_index], D, tmp_mwindows);

		list_of_mwindows.push_back( tmp_mwindows );

		int usage = tmp_mwindows.size();

		PUX[pattern_index]->setUsage( usage );
		PUX[pattern_index]->setGaps( usage * ( PUX[pattern_index]->getSize() -1) );
		PUX[pattern_index]->setPatternCodeLength( log2( (double) D->getSize() / usage) );

		int fills = PUX[pattern_index]->getUsage() * ( PUX[pattern_index]->getSize() -1 );
		int gaps = PUX[pattern_index]->getGaps();
		PUX[pattern_index]->setPreqFillCodeLength( log2( (double) ( 1 + fills + gaps ) / (0.5 + fills) )  );
		PUX[pattern_index]->setPreqGapCodeLength( log2( (double) ( 1 + fills + gaps ) / (0.5 + gaps) )  );
	}
}

double gain_of_pattern_i(vector<Mwindow*> &selected_win, Data *D, uint32 pat_num)
{
	double total_gain = 0;
	for(uint32 win_idx = 0; win_idx < selected_win.size(); win_idx++ )
	{
		if( selected_win[win_idx]->pattern->getPatternNum() == pat_num )
		{
			total_gain += gain( selected_win[win_idx], D );
		}
	}
	return total_gain;
}


double prune_ditto(vector<Pattern*> &list_of_patterns, vector<Mwindow*> &old_selectedwin,
		vector<vector<Mwindow*>> &list_of_mwindows,Data *D, vector<ChoicePattern> &list_of_choice_patterns, double old_codelen, bool full)
{
	double rcodelen = old_codelen;
	vector<uint32> patterns_to_be_pruned;

	for(uint32 i = 0; i < list_of_patterns.size(); i++)
	{

		bool diff = 0;

				if( !full )
				{
					double gain_of_patterni = gain_of_pattern_i( old_selectedwin, D, list_of_patterns[i]->getPatternNum() );
					diff = ct_diff(list_of_patterns, list_of_patterns[i], D, gain_of_patterni);
				}

				if( full || diff )
				{
					if( true || full )
					{
						//cout << " Trying to prune: " << endl;
						//list_of_patterns[i]->printPattern();
					}

					vector<Pattern*> new_list_of_patterns;
					vector<ChoicePattern> new_list_of_choice_patterns;
					vector<vector<Mwindow*>> new_list_of_mwindows;

					for(unsigned int j = 0; j < list_of_patterns.size(); j++)
					{
						if( i != j )
						{
							new_list_of_patterns.push_back( list_of_patterns[j] );
							new_list_of_mwindows.push_back( list_of_mwindows[j] );
						}
					}

					build_list_of_choice_patterns( new_list_of_patterns, new_list_of_choice_patterns, D );

					//cout << "New list of patterns" << endl;

					//print_all_patterns( new_list_of_patterns );

					//cout << "New list of choice patterns" << endl;

					//print_all_choice_patterns( new_list_of_choice_patterns );

					double new_codelen = 0, gain_val = 0;

					vector<int32> susages;
					vector<Mwindow*> selected_windows, previous_selected_windows;
					greedy_ditto( D, new_list_of_patterns , new_codelen, new_list_of_mwindows, selected_windows, susages, nullptr, new_list_of_choice_patterns, true );
					//greedy_ditto( D, new_list_of_patterns , new_allwin_start , nselected_win , new_codelen );



					if( new_codelen < old_codelen )
					{
						//cout << "Pruned: " ;
						//list_of_patterns[i]->printPattern();

						rcodelen = new_codelen;
						//old_codelen = new_codelen;
						patterns_to_be_pruned.push_back( i );
					}
					//cout << "New code len: " << new_codelen << " Old code len: " << old_codelen << endl;
				}
			}

			/*vector<int32> susages;
			vector<Mwindow*> selected_windows, previous_selected_windows;
			greedy_ditto( D, new_list_of_patterns , new_codelen, new_list_of_mwindows, selected_windows, susages, nullptr );*/
			//greedy_ditto( D, new_list_of_patterns , new_allwin_start , nselected_win , new_codelen );

			if( patterns_to_be_pruned.size() > 0 )
			{
				vector<Pattern*> temp_list_of_patterns;
				vector<vector<Mwindow*>> temp_list_of_mwindows;

				for(unsigned int i = 0; i < list_of_patterns.size(); i++)
				{
					bool flag = true;
					for(unsigned int j = 0; j < patterns_to_be_pruned.size(); j++)
					{
						if( patterns_to_be_pruned[j] == i )
						{
							flag = false;
						}
					}
					if( flag )
					{
						temp_list_of_patterns.push_back( list_of_patterns[i] );
						temp_list_of_mwindows.push_back( list_of_mwindows[i] );
					}
				}

				list_of_patterns.clear();
				list_of_mwindows.clear();

				for(unsigned int i = 0; i < temp_list_of_patterns.size(); i++)
				{
					list_of_patterns.push_back( temp_list_of_patterns[i] );
					list_of_mwindows.push_back( temp_list_of_mwindows[i] );
				}
			}

			list_of_choice_patterns.clear();

			build_list_of_choice_patterns( list_of_patterns, list_of_choice_patterns, D );

			//cout << "After pruning: " <<  "Size of chocie patterns: " << list_of_choice_patterns.size() << endl;

			//print_all_choice_patterns( list_of_choice_patterns );

			/*for(unsigned int i = 0; i < list_of_patterns.size(); i++)
			{
				list_of_patterns[i]->setPatternNum(i);
			}*/

			//cout << "P size after pruning: " << list_of_patterns.size() << endl;

			return rcodelen;
		}

void create_singleton_patterns(vector<Pattern*> &list_of_patterns, Data *D)
{
	for(uint32 i = 0; i <= D->getMaxAlphaNum(); i++ )
	{
		if( D->getAlphabetSupport(i) > 0 )
		{
			vector<int> a;
			a.push_back( i );
			Pattern *am = new Pattern( a );
			am->setPatternNum( i );
			if( D->getAlphabetSupport(a[0]) > 0 )
			{
				am->setPatternCodeLength( log2((double) D->getSize() / D->getAlphabetSupport(a[0])) );
			}
			else
			{
				am->setPatternCodeLength( 1 );
			}
			am->setUsage( D->getAlphabetSupport(a[0]) );
			//am->setUsage( 0 );
			am->setGaps(0);
			list_of_patterns.push_back(am);
			a.clear();
		}
	}
}

void create_singleton_windows( vector<Mwindow*> &alignedwin, vector<Pattern*> &list_of_singleton_patterns, Data *D)
{
	unordered_map<uint32,uint32> char_patttern_map;
	for(uint32 i = 0; i < list_of_singleton_patterns.size(); i++)
	{
		char_patttern_map[ list_of_singleton_patterns[i]->charAt(0) ] =  i ;
	}
	vector<int32> stop_pat_vec (1, -1);
	Pattern *stop_pat = new Pattern( stop_pat_vec );
	for(uint32 i = 0; i < D->getSize(); i++)
	{
		if( D->charAt(i) != -1 )
		{
			vector<uint32> pos;
			pos.reserve(1);
			pos[0] = i;
			Mwindow *tmw = new Mwindow( i, i, list_of_singleton_patterns[ char_patttern_map[D->charAt(i)] ], 0, pos, 0, 1 );
			tmw->next = nullptr;
			tmw->prev = nullptr;
			alignedwin.push_back( tmw );
			pos.clear();
		}
		else
		{
			vector<uint32> pos;
			pos.reserve(1);
			pos[0] = i;
			Mwindow *tmw = new Mwindow( i, i, stop_pat, 0, pos, 0, 1 );
			alignedwin.push_back( tmw );
		}
	}
}

class CompareCandidatePatterns
{
public:
	bool operator()(pair<Pattern*,double> p1,pair<Pattern*,double> p2) {
		return p1.second > p2.second;
	}
};

Pattern *merge_pattern(Pattern *p1, Pattern *p2)
{
	Pattern *merged = nullptr;
	vector<int> new_patttern_alpha;
	//new_patttern_alpha.reserve( p1->getSize() + p2->getSize() );
	for(uint32 i = 0; i < p1->getSize(); i++ )
	{
		new_patttern_alpha.push_back( p1->charAt(i) );
	}
	for(uint32 i = p1->getSize(); i < (p1->getSize() + p2->getSize()); i++ )
	{
		new_patttern_alpha.push_back( p2->charAt(i - p1->getSize()) );
	}
	merged = new Pattern( new_patttern_alpha, p1->getSize() );
	new_patttern_alpha.clear();
	return merged;
}

void find_new_candidate_patterns( vector<Pattern*> &list_of_complex_patterns, vector<Pattern*> &combined_list_of_patterns, vector<Mwindow*> &alignment, Data *D,
		priority_queue<pair<Pattern*,double>, vector<pair<Pattern*,double>>, CompareCandidatePatterns> *F)
{
	cout << "find_best_pattern_pairs Num of patterns: " << list_of_complex_patterns.size() << endl;

	Encoding ed(alignment, D, combined_list_of_patterns);
	double codelen = ed.cal_code_length(D, combined_list_of_patterns);
	//cout << "Code length: " << codelen << endl;
	//exit(0);
	//#pragma omp parallel for
	for(uint32 i = 0; i < list_of_complex_patterns.size(); i++)
	{
		//cout << "----- Estimate Iteration ------------ : " << i << endl;
		//list_of_complex_patterns[ i ]->printPattern();

		std::pair <uint32,double> tmp = estimate( list_of_complex_patterns[i], combined_list_of_patterns, alignment, D, ed );
		//cout << "Best Match: " << endl;
		//combined_list_of_patterns[ tmp.first ]->printPattern();
		Pattern *new_merged_pattern = merge_pattern( list_of_complex_patterns[ i ], combined_list_of_patterns[ tmp.first ]);
		//#pragma omp critical
		{
			F->push( make_pair( new_merged_pattern, tmp.second ) );
		}
	}
}



void delete_old_patterns(vector<Pattern*> &list_of_patterns)
{
	for(uint32 k = 0; k < list_of_patterns.size(); k++)
	{
		delete list_of_patterns[k];
	}
	list_of_patterns.clear();
}



void most_frequent_event(int32 s_idx, uint32 before_pos, Data *D, vector<int> &freq, Pattern *p)
{
	if( before_pos == 0 )
	{
		freq[ D->charAt( s_idx - 1 ) ] += 1;
	}
	else
	{
		uint32 k = 0;

		for(uint32 i = s_idx + 1; i < D->getSize(); i++)
		{
			if( D->charAt(i) == p->charAt(k + 1) )
			{
				k++;
			}
			else if( k == (before_pos -1) )
			{
				freq[ D->charAt(i) ] += 1;
			}
			if( k == (p->getSize() - 1))
			{
				if( before_pos == (k + 1) )
				{
					freq[ D->charAt( i + 1) ] += 1;
				}
				break;
			}
		}
	}
	/*else if( before_pos == (p->getSize() + 1) )
	{

	}
	else
	{
		for( int i = s_idx; i <= e_idx; i++ )
		{
			freq[ D->charAt(i) ] += 1;
		}
	}*/
}

Pattern *add_event_before_pos( Pattern *p, uint32 before_pos, uint32 event)
{
	Pattern *merged = nullptr;
	vector<int> new_patttern_alpha;
	//new_patttern_alpha.reserve( p1->getSize() + p2->getSize() );
	for(uint32 i = 0; i < p->getSize(); i++ )
	{
		if( before_pos == i )
		{
			new_patttern_alpha.push_back( event );
		}
		new_patttern_alpha.push_back( p->charAt(i) );
	}

	if( before_pos == p->getSize() )
	{
		new_patttern_alpha.push_back( event );
	}

	merged = new Pattern( new_patttern_alpha );
	new_patttern_alpha.clear();
	return merged;
}

Pattern *recursively_augment_patterns( Pattern *p, vector<Mwindow*> &selected_win, Data *D, int32 before_pos)
{
	vector<int> freq ( D->getNumOfAlphabets(), 0);

	for(uint32 i = 0; i < selected_win.size(); i++ )
	{
		if( selected_win[i]->getUsedLen() == p->getSize() && selected_win[i]->pattern->getPatternNum() == p->getPatternNum() )
		{
			int p1_next_idx = selected_win[i]->getPositionInData(0);
			most_frequent_event( p1_next_idx, before_pos, D, freq, p);
		}
	}



	int max_v = 0, max_idx = -1;
	for(uint32 i = 0; i < freq.size(); i++ )
	{
		if( freq[i] > max_v )
		{
			max_v = freq[i];
			max_idx = i;
		}
	}
	if( max_idx != -1 )
	{
		return add_event_before_pos( p, before_pos, max_idx);
	}
	else
	{
		return nullptr;
	}
}

void save_usages(vector<int32> &last_imp_usages, vector<Pattern*> &list_of_patterns)
{
	last_imp_usages.clear();

	for(uint32 i = 0; i < list_of_patterns.size(); i++)
	{
		last_imp_usages.push_back( list_of_patterns[i]->getUsage() );
	}
}

void save_sort(vector<int32> &last_sort_idx, vector<Pattern*> &list_of_patterns)
{
	last_sort_idx.clear();

	for(uint32 i = 0; i < list_of_patterns.size(); i++)
	{
		last_sort_idx.push_back( list_of_patterns[i]->getSortIndex() );
	}
}

void revert_usages(vector<int32> &last_imp_usages, vector<Pattern*> &list_of_patterns)
{
	for(uint32 i = 0; i < list_of_patterns.size(); i++)
	{
		list_of_patterns[i]->setUsage( last_imp_usages[i] );
	}
}


void restore_pattern_usages( vector<Pattern*> &list_of_patterns, vector<vector<Mwindow*>> &list_of_mwindows )
{
	for(uint32  i = 0; i < list_of_patterns.size(); i++ )
	{
		list_of_patterns[i]->setUsage( list_of_mwindows[i].size() );
	}
}


double estimate_gain_of_new_gap_pattern( double old_codelen, vector<Mwindow*> &selectedwin,
		Pattern *old_candidate, Pattern * gap_candidate, vector<Mwindow*> &windows_of_gap_pattern,
		Data *D, vector<Pattern*> &list_of_patterns, vector<int32> &susages )
{
	EncodingCalucator ec;

	int old_pattern_stream_length = selectedwin.size();
	for(uint32 i = 0; i < susages.size(); i++)
	{
		old_pattern_stream_length += susages[i];
	}

	int old_sum_of_pattern_usages = 0;
	for(uint32 i = 0; i < list_of_patterns.size(); i++)
	{
		old_sum_of_pattern_usages += list_of_patterns[i]->getUsage();
	}

	int viable_windows_of_gap_pattern = 0, gaps_in_viable_windows_of_gap_pattern = 0;
	for(uint32 i = 0; i < windows_of_gap_pattern.size(); i++ )
	{
		if( windows_of_gap_pattern[i]->getNumOfGaps() <= windows_of_gap_pattern[i]->pattern->getSize() )
		{
			viable_windows_of_gap_pattern++;
			gaps_in_viable_windows_of_gap_pattern += windows_of_gap_pattern[i]->getNumOfGaps();
		}
	}

	int new_pattern_stream_length = old_pattern_stream_length - viable_windows_of_gap_pattern;

	int new_usage_of_old_candidate = max( old_candidate->getUsage() - viable_windows_of_gap_pattern, 0 );

	int new_sum_of_pattern_usages = old_sum_of_pattern_usages -old_candidate->getUsage() + new_usage_of_old_candidate + viable_windows_of_gap_pattern;

	double new_codelen = old_codelen;

	new_codelen -= old_candidate->getUsage() * ec.lu( (double) old_pattern_stream_length / old_candidate->getUsage() );

	if( new_usage_of_old_candidate > 0 )
	{
		new_codelen += new_usage_of_old_candidate * ec.lu( (double) old_pattern_stream_length / new_usage_of_old_candidate );
	}

	new_codelen += viable_windows_of_gap_pattern * ec.lu( (double) old_pattern_stream_length / viable_windows_of_gap_pattern );

	int gap_char = gap_candidate->charAt( old_candidate->getMergePos() );

	new_codelen -= susages[ gap_char ] * ec.lu( (double) old_pattern_stream_length / susages[ gap_char ] );

	int new_susage_of_gap_char = max( susages[ gap_char ] - viable_windows_of_gap_pattern , 0 );

	if( new_susage_of_gap_char > 0 )
	{
		new_codelen += new_susage_of_gap_char * ec.lu( (double) old_pattern_stream_length / new_susage_of_gap_char );
	}

	new_codelen += new_pattern_stream_length * ( ec.lu( new_pattern_stream_length ) - ec.lu( old_pattern_stream_length ) );

	int old_gaps_of_old_candidiate = old_candidate->getGaps();

	int new_gaps_of_old_candidiate = max( old_gaps_of_old_candidiate - gaps_in_viable_windows_of_gap_pattern - viable_windows_of_gap_pattern, 0 );

	new_codelen += ec.ln( new_gaps_of_old_candidiate ) - ec.ln( old_gaps_of_old_candidiate );

	new_codelen += ec.ln( gaps_in_viable_windows_of_gap_pattern );

	int old_fills_of_old_candidate = old_candidate->getUsage() * ( old_candidate->getSize() -1 );
	int new_fills_of_old_candidate =  new_usage_of_old_candidate * ( old_candidate->getSize() -1 );

	int fills_of_new_gap_pattern = viable_windows_of_gap_pattern * ( gap_candidate->getSize() - 1 );

	new_codelen -= exact_prequential_length_of_binary_sequence( old_fills_of_old_candidate, old_gaps_of_old_candidiate, 0.5 );
	new_codelen += exact_prequential_length_of_binary_sequence( new_fills_of_old_candidate, new_gaps_of_old_candidiate, 0.5 );
	new_codelen += exact_prequential_length_of_binary_sequence( fills_of_new_gap_pattern, gaps_in_viable_windows_of_gap_pattern, 0.5 );

	if( new_usage_of_old_candidate <= 0 )
	{
		for(uint32 j = 0; j < old_candidate->getSize(); j++ )
		{
			new_codelen -= ec.lu( (double)D->getSize() / D->getAlphabetSupport( old_candidate->charAt(j)) );
		}
	}

	for(uint32 j = 0; j < gap_candidate->getSize(); j++ )
	{
		new_codelen += ec.lu( (double)D->getSize() / D->getAlphabetSupport( gap_candidate->charAt(j)) );
	}

	if( new_usage_of_old_candidate > 0 )
	{
		new_codelen += ec.ln( list_of_patterns.size() + 1 ) - ec.ln( list_of_patterns.size()  );
		new_codelen += ec.approxlogchoose( new_sum_of_pattern_usages, list_of_patterns.size() + 1 ) - ec.approxlogchoose( old_sum_of_pattern_usages, list_of_patterns.size() );
	}
	else
	{
		new_codelen += ec.approxlogchoose( new_sum_of_pattern_usages, list_of_patterns.size() ) - ec.approxlogchoose( old_sum_of_pattern_usages, list_of_patterns.size() );
	}

	return (old_codelen - new_codelen);
}

void check_occurance_of_pattern( vector<Mwindow*> &selected_win )
{
	int count = 0;
	for(uint32 i = 0; i < selected_win.size(); i++ )
	{
		if( selected_win[i]->pattern->charAt(0) == 15 )
		{
			count++;
		}
	}
	cout << " num of found win: " << count << endl;
}

void copy_selected_win_list( vector<Mwindow*> &l1, vector<Mwindow*> &l2 )
{
	for(uint32  i = 0; i < l2.size(); i++ )
	{
		l1.push_back( l2[i] );
	}
}

void renumber_patterns_with_index_as_pattern_number( vector<Pattern*> &list_of_patterns )
{
	for(uint32  i = 0; i < list_of_patterns.size(); i++ )
	{
		list_of_patterns[i]->setPatternNum( i );
	}
}

void copy_pattern_vector( vector<Pattern*> &lp1, vector<Pattern*> &lp2 )
{
	for(uint32 i = 0; i < lp2.size(); i++ )
	{
		lp1.push_back( lp2[i] );
	}
}

bool compMwindows( Mwindow* const a, Mwindow* const b)
{
    return a->getStartIndex() < b->getStartIndex();
}

void create_alignment( vector<Mwindow*> &singleton_windows, vector<Mwindow*> &selected_win, vector<Mwindow*> &alignment, uint32 data_length )
{
	vector<bool> covered ( data_length, false);
	for(uint32 i = 0; i < selected_win.size(); i++ )
	{
		alignment.push_back( selected_win[i] );

		for( uint32 j = 0; j < selected_win[i]->getUsedLen(); j++ )
		{
			covered[ selected_win[i]->getPositionInData(j) ] = true;
		}

	}

	for(uint32  i = 0; i < covered.size(); i++ )
	{
		if( !covered[i] )
		{
			alignment.push_back( singleton_windows[i] );
		}
	}

	stable_sort( alignment.begin(), alignment.end(), compMwindows);
}

void set_pattern_code_lengths( vector<Pattern*> &list_of_patterns, vector<int32> &susages  )
{
	uint32 pattern_stream_length = 0;
	for(uint32 i = 0; i < susages.size(); i++ )
	{
		pattern_stream_length += susages[i];
	}
	for(uint32 i = 0; i < list_of_patterns.size(); i++ )
	{
		pattern_stream_length += list_of_patterns[i]->getUsage();
	}
	for(uint32 i = 0; i < list_of_patterns.size(); i++ )
	{
		if( list_of_patterns[i]->getUsage() > 0 )
		{
			list_of_patterns[i]->setPatternCodeLength( log2( (double) pattern_stream_length / list_of_patterns[i]->getUsage() ) );
			if( list_of_patterns[i]->getSize() > 0 )
			{
				int fills = list_of_patterns[i]->getUsage() * ( list_of_patterns[i]->getSize() -1 );
				int gaps = list_of_patterns[i]->getGaps();
				list_of_patterns[i]->setPreqFillCodeLength( log2( (double) ( 1 + fills + gaps ) / (0.5 + fills) )  );
				list_of_patterns[i]->setPreqGapCodeLength( log2( (double) ( 1 + fills + gaps ) / (0.5 + gaps) )  );
			}
		}
	}
}

bool compMwindowVector( vector<Mwindow*> const a, vector<Mwindow*> const b)
{
    return a[0]->pattern->getSortIndex() < b[0]->pattern->getSortIndex();
}

void get_all_mwindows_parallel( Data *D, priority_queue<pair<Pattern*,double>, vector<pair<Pattern*,double>>, CompareCandidatePatterns> *F, vector<vector<Mwindow*>> &tmp_list_of_mwindows )
{
	priority_queue<pair<Pattern*,double>, vector<pair<Pattern*,double>>, CompareCandidatePatterns> *F_tmp =
				new priority_queue<pair<Pattern*,double>, vector<pair<Pattern*,double>>, CompareCandidatePatterns>;

	vector<Pattern*> tmp_list_of_patterns;
	vector<bool> useful_pattern ( F->size() + 1, true);

	while( !F->empty() )
	{
		tmp_list_of_patterns.push_back( F->top().first );
		tmp_list_of_patterns[ tmp_list_of_patterns.size() - 1 ]->setSortIndex( tmp_list_of_patterns.size() - 1 );
		F_tmp->push( F->top() );
		F->pop();
	}


    //#pragma omp parallel for
	for( uint32 i = 0; i < tmp_list_of_patterns.size() ; i++ )
	{
		Pattern *new_pattern;

		/*#pragma omp critical
		{*/
			new_pattern = tmp_list_of_patterns[i];
			//new_pattern->printPattern();
		//}

		vector<Mwindow*> tmp_mwindows;
		find_windows( new_pattern, D, tmp_mwindows);
		//find_win_pq( D, new_pattern, tmp_mwindows);

		//#pragma omp critical
		//{
			uint32 usage = tmp_mwindows.size();

			if( usage > 0 )
			{
				new_pattern->setUsage( usage );
				new_pattern->setGaps( usage * ( new_pattern->getSize() -1) );
				new_pattern->setPatternCodeLength( log2( (double) D->getSize() / usage) );

				int fills = new_pattern->getUsage() * ( new_pattern->getSize() -1 );
				int gaps = new_pattern->getGaps();
				new_pattern->setPreqFillCodeLength( log2( (double) ( 1 + fills + gaps ) / (0.5 + fills) )  );
				new_pattern->setPreqGapCodeLength( log2( (double) ( 1 + fills + gaps ) / (0.5 + gaps) )  );
				tmp_list_of_mwindows.push_back( tmp_mwindows );
				//cout << "Found windows: " << tmp_mwindows.size() << endl;
			}
			else
			{
				useful_pattern[i] = false;
			}
		//}

	}
	//exit(0);
	#pragma omp barrier
	stable_sort( tmp_list_of_mwindows.begin(), tmp_list_of_mwindows.end(), compMwindowVector );
	for( uint32 i = 0; i < F_tmp->size(); i++ )
	{
		if( useful_pattern[i] )
		{
			F->push( F_tmp->top() );
		}
		F_tmp->pop();
	}
}

void print_change_in_usages_sort_index( vector<int32> &last_usages, vector<int32> &last_sort_idx, vector<Pattern*> &list_of_patterns )
{
	for( uint32 i = 0; i < list_of_patterns.size(); i++ )
	{
		list_of_patterns[i]->printPattern();
		cout << "Usage: " << (int32)list_of_patterns[i]->getUsage() - last_usages[i] << " - Sort idx: " << (int32)list_of_patterns[i]->getSortIndex() - last_sort_idx[i] << endl;
	}
}

int sqs_search_ditto(std::string path_to_dataset,  bool interpret_patterns)
{
	bool squeezed = false;
	double time_to_sqs = 0;
	clock_t startTime = clock();
	Data *D =new Data( path_to_dataset, INT_MAX );

	vector<Mwindow*> selected_win, tmp_selected_win, singleton_windows, alignment;

	vector<vector<Mwindow*>> list_of_mwindows_of_selected_patterns, buffer_list_of_mwindows;

	vector<Pattern*> combined_list_of_patterns, list_of_complex_patterns, list_of_singleton_patterns;
	vector<ChoicePattern> list_of_complex_choice_patterns;

	create_singleton_patterns( list_of_singleton_patterns,  D);

	create_singleton_windows( singleton_windows, list_of_singleton_patterns, D);

	bool changes = true;


	double old_code_len = INT_MAX;



	priority_queue<pair<Pattern*,double>, vector<pair<Pattern*,double>>, CompareCandidatePatterns> *F =
				new priority_queue<pair<Pattern*,double>, vector<pair<Pattern*,double>>, CompareCandidatePatterns>;

	while( changes )
	{
		//cout << "------------------ Pattern size increased -------------------" << endl;
		uint32 num_of_initial_candidates = 0;
		if( old_code_len < INT_MAX ) // if not first iteration
		{
			//exit(0);
			double final_codelen = 0;
			selected_win.clear();

			restore_pattern_usages( list_of_complex_patterns, list_of_mwindows_of_selected_patterns );
			vector<int32> susages;
			greedy_ditto( D, list_of_complex_patterns , final_codelen, list_of_mwindows_of_selected_patterns, selected_win, susages, nullptr, list_of_complex_choice_patterns, true );

			old_code_len = final_codelen;

			alignment.clear();
			renumber_patterns_with_index_as_pattern_number( combined_list_of_patterns );
			create_alignment( singleton_windows, selected_win, alignment, D->getSize() );
			//set_pattern_code_lengths( combined_list_of_patterns, susages  );
			//cout << "Alignment -- " << endl;
			//print_alignment( alignment, 500 );

			find_new_candidate_patterns( combined_list_of_patterns, combined_list_of_patterns, alignment, D, F);
		}
		else
		{
			combined_list_of_patterns.clear();
			copy_pattern_vector( combined_list_of_patterns, list_of_singleton_patterns );
			renumber_patterns_with_index_as_pattern_number( combined_list_of_patterns );
			//set_pattern_code_lengths( combined_list_of_patterns, susages  );

			find_new_candidate_patterns( combined_list_of_patterns, combined_list_of_patterns, singleton_windows, D, F);
		}



		changes = false;
		num_of_initial_candidates = combined_list_of_patterns.size();
		//selected_win.clear();

		//cout << "New F size: " << F.size() << endl;


		/*buffer_list_of_mwindows.clear();
		get_all_mwindows_parallel( D, F, buffer_list_of_mwindows );
		cout << "Window lists found: " << buffer_list_of_mwindows.size() << endl;
		uint32 current_candidate = 0;*/

		while( !F->empty() )
		{

			vector<Pattern*> PUX;
			//cout << "P size: " << P.size() << endl;

			for(uint32 i = 0; i < list_of_complex_patterns.size(); i++)
			{
				PUX.push_back( list_of_complex_patterns[i] );
			}


			Pattern *new_candidate = F->top().first;
			double est_gain = F->top().second;
			F->pop();
			/*cout << "New candidiate" << endl;
			new_candidate->printPattern();
			cout << "Est gain: " << est_gain << endl;*/

			new_candidate->setPatternNum( max_pattern_num( PUX ) + 1 );

			PUX.push_back( new_candidate );

			double final_codelen = 0;

			//pat_num_check( list_of_patterns );
			vector<int32> new_susages;

			/*if( current_candidate < num_of_initial_candidates )
			{
				list_of_mwindows_of_selected_patterns.push_back( buffer_list_of_mwindows[current_candidate++] );
				cout << "Size of found windows: " << list_of_mwindows_of_selected_patterns[ list_of_mwindows_of_selected_patterns.size() - 1 ].size() << endl;
				//list_of_mwindows_of_selected_patterns[ list_of_mwindows_of_selected_patterns.size() - 1 ][0]->pattern->printPattern();
			}
			else
			{*/
				append_mwindows_of_new_pattern( D, list_of_mwindows_of_selected_patterns, new_candidate);
			//}
			//selected_win.clear();
			restore_pattern_usages( PUX, list_of_mwindows_of_selected_patterns );

			if( list_of_mwindows_of_selected_patterns[ list_of_mwindows_of_selected_patterns.size() - 1 ].size() > 0 && est_gain < 0)
			{
				//tmp_selected_win.clear();
				//copy_selected_win_list( tmp_selected_win, selected_win );

				greedy_ditto( D, PUX , final_codelen, list_of_mwindows_of_selected_patterns, selected_win, new_susages, new_candidate, list_of_complex_choice_patterns, false);
			}
			else
			{
				final_codelen = old_code_len;
			}
			//check_occurance_of_pattern( selected_win );



			if( old_code_len > final_codelen )
			{

				list_of_complex_patterns.push_back( new_candidate );
				cout << "Accepted: " << endl;
				cout << "New candidiate: " << " merge pos: " << new_candidate->getMergePos() <<endl;
				new_candidate->printPattern();


				int32 choice_pattern_that_can_be_added = check_if_new_pattern_can_be_made_a_choice_pattern( new_candidate, list_of_complex_choice_patterns, D );

				if( choice_pattern_that_can_be_added != -1 )
				{
					list_of_complex_choice_patterns[ choice_pattern_that_can_be_added ].add_pattern( new_candidate, D );
				}
				else
				{
					ChoicePattern simple_cp( new_candidate, D );
					list_of_complex_choice_patterns.push_back( simple_cp );
				}



				if( new_candidate->getSize() > 1 )
				{

					vector<Pattern*> new_candidate_frequent_gap_patterns;
					for( uint32 before_pos = 1; before_pos < new_candidate->getSize(); before_pos++ )
					{
						new_candidate_frequent_gap_patterns.push_back( recursively_augment_patterns( new_candidate, selected_win, D, before_pos));
					}
					for( uint32 i = 0; i < new_candidate_frequent_gap_patterns.size(); i++ )
					{
						Pattern *new_candidate_frequent_gap_pattern = new_candidate_frequent_gap_patterns[i];
						//vector<Mwindow*> new_candidate_frequent_gap_pattern_windows;
						//find_windows(new_candidate_frequent_gap_pattern, D, new_candidate_frequent_gap_pattern_windows);
						//double est_gain_of_new_candidate_frequent_gap_pattern = estimate_gain_of_new_gap_pattern( final_codelen, selected_win, new_candidate, new_candidate_frequent_gap_pattern, new_candidate_frequent_gap_pattern_windows,
						//	D, P, new_susages );

						if( new_candidate_frequent_gap_pattern != nullptr /*&& est_gain_of_new_candidate_frequent_gap_pattern > 0*/ )
						{
							//cout << "New frequent gap pattern: " << endl;
							//new_candidate_frequent_gap_pattern->printPattern();
							//cout << "Est gain: " <<  est_gain_of_new_candidate_frequent_gap_pattern << endl;
							F->push( make_pair( new_candidate_frequent_gap_pattern, -1 ) );
						}
					}
					//delete_list( alignedwin_start );
				}
				//cout << "Pruning (in search): " << endl;

				if( list_of_complex_patterns.size() > 1 )
				{
					final_codelen = prune_ditto(list_of_complex_patterns, selected_win, list_of_mwindows_of_selected_patterns, D, list_of_complex_choice_patterns, final_codelen, false);

				}

				tmp_selected_win.clear();
				//copy_selected_win_list( tmp_selected_win, selected_win );
				selected_win.clear();

				old_code_len = final_codelen;
				changes = true;
				cout << double( clock() - startTime ) / (double)CLOCKS_PER_SEC<< " seconds.  - " ;
				cout << " Current codelen: " << old_code_len << endl;
			}
			else
			{
				selected_win.clear();
				copy_selected_win_list( selected_win, tmp_selected_win );
				vector<Mwindow*> junk_windows = list_of_mwindows_of_selected_patterns[ list_of_mwindows_of_selected_patterns.size() - 1 ];
				list_of_mwindows_of_selected_patterns.pop_back();
				delete_mwindows_in_vector( junk_windows );
				PUX.pop_back();
				delete new_candidate;
			}

			if( !squeezed )
			{
				if( final_codelen <   680236 )
				{
					time_to_sqs = double( clock() - startTime ) / (double)CLOCKS_PER_SEC;
					squeezed = true;
					changes = false;
					//break;
				}
			}


		}
		cout << "F empty!" << endl;
		combined_list_of_patterns.clear();
		copy_pattern_vector( combined_list_of_patterns, list_of_singleton_patterns );
		copy_pattern_vector( combined_list_of_patterns, list_of_complex_patterns );

		//changes  = false;
	}

	cout << "Final codelen: " << old_code_len << endl;
	//final_prune( P, D);

	cout << double( clock() - startTime ) / (double)CLOCKS_PER_SEC<< " seconds.  - " ;
	cout << " Current codelen: " << old_code_len << endl;
	cout << "Time to SQS: " << time_to_sqs << endl;

	cout << "ISD: " << avg_isd( list_of_complex_patterns ) << endl;
	cout << "CS: " << avg_cs( list_of_complex_patterns ) << endl;

	cout << "Num of seq: " << D->getNumOfSeq() << endl;

	print_all_choice_patterns( list_of_complex_choice_patterns, D );
	//print_all_patterns( list_of_complex_patterns );

	delete D;

	return 0;
}



