/*
 * sqs.cpp
 *
 *  Created on: Mar 11, 2015
 *      Author: abhattac
 */
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <limits.h>

#include "../misc/Pattern.h"
#include "../misc/EncodingCalucator.h"
#include <math.h>

#include "../misc/Data.h"
#include "../misc/DataCover.h"
#include "../misc/Mwindow.h"
#include "../misc/common_functions.h"

using namespace std;



double calc_uncompressed_size(Data *D)
{
	double len = 0;
	EncodingCalucator ec;
	len += ec.ln(D->getSize()) + 3 * ec.ln(1) + ec.ln(D->getNumOfAlphabets()) + ec.approxlogchoose(D->getSize()-1,D->getNumOfAlphabets()-1) ;
	for(int i=0; i<D->getNumOfAlphabets(); i++)
	{
		len += D->getAlphabetSupport(i) * log2((double)D->getSize()/D->getAlphabetSupport(i));
	}
	return len;
}

Pattern **get_patterns(string filename, int num, int len)
{
	Pattern **XX = new Pattern*[num];
	ifstream is(filename);     // open file

	char c;

	int tmp = 0, pospow = 1, tnum = 0, tlen = 0, ttlen = 0;
	int tstore[5];
	vector<int> tpat;
	tpat.reserve( len );
	while( is.get(c) )          // loop getting single characters
	{
		if(c != ',')
		{
			tstore[ttlen++] = (int)(c - 48);
		}
		else
		{
			ttlen --;
			pospow = 1;
			tmp = 0;
			while (ttlen >= 0)
			{
				tmp = tmp + pospow * tstore[ttlen];
				pospow *= 10;
				ttlen --;
			}
			ttlen++;

			tpat[tlen++] = tmp;

			if( tlen == len )
			{
				XX[tnum++] = new Pattern( tpat );
				tlen = 0;

			}
		}

	}

	is.close();
	return XX;
}

int next(Mwindow *mtmp)
{
	int i = 0, j = 0;
	Mwindow *t = mtmp;
	while( t != nullptr )
	{
		if( t->getStartIndex() > mtmp->getEndIndex() )
		{
			j = i;
			break;
		}
		i++;
		t = t->next;
	}
	return j;
}

bool compare_window_positions(Mwindow *mw1, Mwindow *mw2)
{
	for(int i = 0; i < mw1->pattern->getSize(); i++)
	{
		for(int j = 0; j < mw2->pattern->getSize(); j++)
		{
			if( mw1->getPositionInData(i) == mw2->getPositionInData(j) )
			{
				return false;
			}
		}
	}
	return true;
}

int new_next(Mwindow *mtmp)
{
	int i = 0, j = 0;
	Mwindow *t = mtmp;
	while( t != nullptr )
	{
		if( compare_window_positions( t, mtmp ) )
		{
			j = i;
			break;
		}
		i++;
		t = t->next;
	}
	return j;
}


double calc_act_code_len_preq(vector<int> &susages, vector<Pattern*> &list_of_patterns, Data *D) {

	int pattern_stream_length = 0, sum_of_usages = 0 , num_of_patterns = 0, num_of_used_chars = 0;

	for(unsigned int i = 0; i < list_of_patterns.size(); i++)
	{
		sum_of_usages += list_of_patterns[i]->getUsage();

		if( list_of_patterns[i]->getUsage() > 0 )
		{
			num_of_patterns++;
		}
	}

	for(unsigned int i = 0; i < susages.size(); i++)
	{
		if( susages[i] > 0 )
		{
			num_of_used_chars++;
		}
	}

	pattern_stream_length = sum_of_usages;

	EncodingCalucator ec;

	double lctd = ec.ln( D->getSize() ) + ec.approxlogchoose(D->getSize() - 1, num_of_used_chars - 1) + ec.ln( num_of_patterns + 1 ) ;

	lctd += ec.ln( sum_of_usages + 1 ) + ec.approxlogchoose( sum_of_usages - 1, num_of_patterns - 1) ;
	//cout << "sum" << sum_of_usages << endl;
	for(unsigned int i = 0; i < list_of_patterns.size(); i++)
	{

		lctd += ec.ln( list_of_patterns[i]->getSize() );
		//cout << "Gaps: " << i << " " <<  XX[i]->getGaps() << endl;
		for(int j = 0; j < list_of_patterns[i]->getSize(); j++ )
		{
			lctd += ec.lu( (double)D->getSize() / D->getAlphabetSupport(list_of_patterns[i]->charAt(j)) );
		}

	}
	//cout << "lctd: " << lctd << endl;
	double ldct = ec.ln(1);

	for(int i = 0; i < D->getMaxAlphaNum(); i++ )
	{
		pattern_stream_length += susages[i];
	}

	for(int i = 0; i < D->getMaxAlphaNum(); i++ )
	{
		if( susages[i] > 0 )
		{
			ldct += susages[i] * ec.lu((double)pattern_stream_length / susages[i]);
		}
		else if( susages[i] < 0 )
		{
			cout << "usage less than zero for: " << "i: " << i << " ->> " << susages[i] << endl;
			//exit(0);
		}
	}

	//cout << "ldct: " << ldct << endl;

	for(unsigned int i = 0; i < list_of_patterns.size(); i++)
	{
		if( list_of_patterns[i]->getUsage() > 0 )
		{
			ldct += list_of_patterns[i]->getUsage() * ec.lu((double)pattern_stream_length / list_of_patterns[i]->getUsage());
			int fills = list_of_patterns[i]->getUsage() * ( list_of_patterns[i]->getSize() -1 );
			int gaps = list_of_patterns[i]->getGaps();
			//double pcl = approx_prequential_legth_of_binary_sequence( (fills + gaps), 2, gaps );
			double pcl = exact_prequential_length_of_binary_sequence( fills, gaps, 0.5 );
			//cout << "pcl: " << pcl << " fills: " << fills << " gaps: " << gaps << endl;
			ldct += pcl;

		}
	}

	return ldct + lctd;

}
/*
int hist[1000][10];
int curr_itr = 0;
 */

double calc_act_code_len2(vector<int> &susages, vector<Pattern*> &list_of_patterns, Data *D) {

	int cp_len = 0, sum_of_usages = 0 , num_of_patterns = 0, num_of_used_chars = 0;

	for(unsigned int i = 0; i < list_of_patterns.size(); i++)
	{
		sum_of_usages += list_of_patterns[i]->getUsage();

		if( list_of_patterns[i]->getUsage() > 0 )
		{
			num_of_patterns++;
		}
	}

	for(unsigned int i = 0; i < susages.size(); i++)
	{
		if( susages[i] > 0 )
		{
			num_of_used_chars++;
		}
	}

	cp_len = sum_of_usages;
	//cout << "Cp len: " << cp_len << endl;
	EncodingCalucator ec;

	double lctd = ec.ln( D->getSize() ) + ec.approxlogchoose(D->getSize() - 1, num_of_used_chars - 1) + ec.ln( num_of_patterns + 1 ) ;

	lctd += ec.ln( sum_of_usages + 1 ) + ec.approxlogchoose( sum_of_usages - 1, num_of_patterns - 1) ;
	//cout << "sum" << sum_of_usages << endl;
	for(unsigned int i = 0; i < list_of_patterns.size(); i++)
	{

		lctd += ec.ln( list_of_patterns[i]->getSize() ) + ec.ln( list_of_patterns[i]->getGaps() + 1 );
		//cout << "Gaps: " << i << " " <<  XX[i]->getGaps() << endl;
		for(int j = 0; j < list_of_patterns[i]->getSize(); j++ )
		{
			lctd += ec.lu( (double)D->getSize() / D->getAlphabetSupport(list_of_patterns[i]->charAt(j)) );
		}

	}
	//cout << "lctd: " << lctd << endl;
	double ldct = ec.ln(1);

	for(int i = 0; i < D->getMaxAlphaNum(); i++ )
	{
		cp_len += susages[i];
	}

	for(int i = 0; i < D->getMaxAlphaNum(); i++ )
	{
		if( susages[i] > 0 )
		{
			ldct += susages[i] * ec.lu((double)cp_len / susages[i]);
		}
		else if( susages[i] < 0 )
		{
			cout << "usage less than zero for: " << "i: " << i << " ->> " << susages[i] << endl;
			//exit(0);
		}
	}

	//cout << "ldct: " << ldct << endl;

	for(unsigned int i = 0; i < list_of_patterns.size(); i++)
	{
		if( list_of_patterns[i]->getUsage() > 0 )
		{
			ldct += list_of_patterns[i]->getUsage() * ec.lu((double)cp_len / list_of_patterns[i]->getUsage());
			int fills = list_of_patterns[i]->getUsage() * ( list_of_patterns[i]->getSize() -1 );
			if( list_of_patterns[i]->getGaps() > 0 )
			{
				ldct += list_of_patterns[i]->getGaps() * ec.lu( ( (double) list_of_patterns[i]->getGaps() + fills ) / list_of_patterns[i]->getGaps() );
			}
			ldct += fills * ec.lu( ( (double) list_of_patterns[i]->getGaps() + fills ) / fills );
		}
	}

	//cout << " Align iteration code length: " << (ldct + lctd) << endl;

	return ldct + lctd;

}

void dynamic_align(Mwindow *allwin_end, double *o, Data *D, int N)
{
	Mwindow *allwin_tmp = allwin_end;
	for(int i = N; i > 0 ; i--, allwin_tmp = allwin_tmp->prev)
	{
		double c = 0;

		int next_win = next( allwin_tmp );

		if( next_win != 0 )
		{
			c = o[ next_win + i ];
		}

		double gn = gain( allwin_tmp, D);
		//allwin_tmp->pattern->printPattern();
		//allwin_tmp->printWin();
		//cout << "gain: " << gn << endl;
		if( ( gn + c ) > o[i+1] )
		{
			o[i] = gn + c;
		}
		else
		{
			o[i] = o[i+1];
		}

	}
}

Mwindow *get_end_of_list(Mwindow *allwin_start)
{
	Mwindow *allwin_tmp = allwin_start, *allwin_end = nullptr;
	while( allwin_tmp != nullptr)
	{
		allwin_end = allwin_tmp;
		allwin_tmp = allwin_tmp->next;
	}
	return allwin_end;
}

void reset_gaps_of_patterns(vector<Pattern*> &list_of_patterns, vector<int> &old_gaps)
{
	for(unsigned int i=0; i < list_of_patterns.size(); i++)
	{
		//list_of_patterns[i]->setUsage(0);
		old_gaps[i] = list_of_patterns[i]->getGaps();
		list_of_patterns[i]->setGaps(0);
		//list_of_patterns[i]->setPatternCodeLength(0);
	}
}

void init_pattern_code_lengths( vector<Pattern*> &list_of_patterns, vector<int> &susages,
		vector<int> &new_pusages, vector<int> &new_gaps)
{
	int sum_of_usages = 0;
	for( unsigned int i = 0; i < list_of_patterns.size(); i++)
	{
		sum_of_usages += new_pusages[i];
	}
	for( unsigned int i = 0; i < susages.size(); i++)
	{
		sum_of_usages += susages[i];
	}

	for( unsigned int i = 0; i < list_of_patterns.size(); i++)
	{
		list_of_patterns[i]->setUsage( new_pusages[i] );
		list_of_patterns[i]->setGaps( new_gaps[i] );
		if( new_pusages[i] > 0 )
		{
			list_of_patterns[i]->setPatternCodeLength( log2( (double) sum_of_usages / list_of_patterns[i]->getUsage() ) ) ;
		}
		else
		{
			//list_of_patterns[i]->setPatternCodeLength( INT_MAX ) ;
		}
	}
}

void init_pattern_code_lengths_preq( vector<Pattern*> &list_of_patterns, vector<int> &susages,
		vector<int> &new_pusages, vector<int> &new_gaps)
{
	int sum_of_usages = 0;
	for( unsigned int i = 0; i < list_of_patterns.size(); i++)
	{
		sum_of_usages += new_pusages[i];
	}
	for( unsigned int i = 0; i < susages.size(); i++)
	{
		sum_of_usages += susages[i];
	}

	for( unsigned int i = 0; i < list_of_patterns.size(); i++)
	{
		list_of_patterns[i]->setUsage( new_pusages[i] );
		list_of_patterns[i]->setGaps( new_gaps[i] );

		int fills = list_of_patterns[i]->getUsage() * ( list_of_patterns[i]->getSize() -1 );
		int gaps = list_of_patterns[i]->getGaps();
		list_of_patterns[i]->setPreqFillCodeLength( log2( (double) ( 1 + fills + gaps ) / (0.5 + fills) )  );
		list_of_patterns[i]->setPreqGapCodeLength( log2( (double) ( 1 + fills + gaps ) / (0.5 + gaps) )  );

		if( new_pusages[i] > 0 )
		{
			list_of_patterns[i]->setPatternCodeLength( log2( (double) sum_of_usages / list_of_patterns[i]->getUsage() ) ) ;
		}
		else
		{
			//list_of_patterns[i]->setPatternCodeLength( INT_MAX ) ;
		}
	}
}

void reconstruct( vector<int> &selected_win, vector<Pattern*> &list_of_patterns,
		double *o, Mwindow *allwin_start, vector<int> &susages, Data *D)
{
	int o_idx = 1;
	Mwindow *allwin_tmp = allwin_start;
	vector<int> new_pusages ( list_of_patterns.size(), 0);
	vector<int> new_gaps ( list_of_patterns.size(), 0);
	while( allwin_tmp != nullptr )
	{
		if( o[o_idx] > o[o_idx + 1] )
		{
			//cout << "Selected" << endl;
			selected_win[ o_idx ] = 1;

			int win_idx = allwin_tmp->pattern->getPatternNum();

			new_pusages[ win_idx ] += 1 ;
			new_gaps[ win_idx ] += allwin_tmp->getEndIndex() -allwin_tmp->getStartIndex() - allwin_tmp->pattern->getSize() + 1;

			for(unsigned int i = 0; i < allwin_tmp->pattern->getSize(); i++ )
			{
				susages[ allwin_tmp->pattern->charAt(i) ] = susages[ allwin_tmp->pattern->charAt(i) ] - 1;
			}

			int next_win = next( allwin_tmp );

			if( next_win != 0 )
			{
				while( next_win > 0 )
				{
					o_idx++;
					allwin_tmp = allwin_tmp->next;
					next_win --;
				}
				continue;
			}
			else
			{
				break;
			}
		}

		o_idx++;
		allwin_tmp = allwin_tmp->next;

	}

	init_pattern_code_lengths_preq( list_of_patterns, susages, new_pusages, new_gaps );
}

void init_susages(Data *D, vector<int> &susages)
{
	for(int i = 0; i < D->getMaxAlphaNum(); i++)
	{
		susages.push_back( D->getAlphabetSupport(i) );
	}
}

int sum_of_pattern_usages(vector<Pattern*> &list_of_patterns)
{
	int sum_of_usage  = 0;
	for(unsigned int i = 0; i < list_of_patterns.size(); i++)
	{
		sum_of_usage += list_of_patterns[i]->getUsage();
	}
	return sum_of_usage;
}

void set_pattern_code_lengths(vector<Pattern*> &list_of_patterns, int sum_of_usages, Data *D)
{
	for(unsigned int i = 0; i < list_of_patterns.size(); i++)
	{
		list_of_patterns[i]->setPatternCodeLength( log2( (double)(D->getSize() - sum_of_usages) / list_of_patterns[i]->getUsage() ) );
	}
}

void align(Mwindow *allwin, Data *D, vector<Pattern*> &list_of_patterns,
		vector<int> &selected_win, double *final_codelen, double *sum_of_gainval)
{
	Mwindow *allwin_start = allwin, *allwin_end = nullptr;

	int N = length_list( allwin_start);

	allwin_end = get_end_of_list( allwin_start);

	double o[N+2];

	memset(o, 0, (N+2)*sizeof(double));

	dynamic_align( allwin_end, o, D, N);

	vector<int> susages;

	init_susages( D, susages);

	reconstruct( selected_win, list_of_patterns, o, allwin_start, susages, D);

	*final_codelen = calc_act_code_len_preq(susages, list_of_patterns, D);

	//cout << "Final code len: " << *final_codelen << endl;

	//cout << "o[1] : " << o[1] << endl;

	*sum_of_gainval = o[1];
}


void init_list_back_ptrs(Mwindow* merged_win)
{
	Mwindow *prev = merged_win;

	merged_win = merged_win->next;

	while( merged_win != nullptr )
	{
		merged_win->prev = prev;
		prev = merged_win;
		merged_win = merged_win->next;
	}
}

void save_prev_usages(int *prev_usages, vector<Pattern*> &list_of_patterns)
{
	for(unsigned int i = 0; i < list_of_patterns.size(); i++)
	{
		prev_usages[i] = list_of_patterns[i]->getUsage();
	}

}

void dynamic_sqs(Data *D, Mwindow *merged_win, vector<Pattern*> &list_of_patterns,
		vector<int> &selected_win, double *final_codelen, double *sum_gain_val)
{

	Mwindow *oldmergedwin = merged_win;

	init_list_back_ptrs( merged_win );


	int prev_usages[list_of_patterns.size()];

	save_prev_usages( prev_usages, list_of_patterns);

	int flag = 1;

	int N = length_list( merged_win );

	//memset(selected_win, 0, (N+2)*sizeof(int));

	int count = 25;
	while( flag )
	{
		merged_win = oldmergedwin;
		//cout << " -------------------------- New Algin Iteration ------------------------ " << endl;
		align( merged_win , D, list_of_patterns, selected_win, final_codelen, sum_gain_val);
		for(unsigned int i = 0; i < list_of_patterns.size(); i++)
		{
			/*if( true /*list_of_patterns[i]->getSize() == 2 && list_of_patterns[i]->charAt(0) == 900 && list_of_patterns[i]->charAt(1) == 553 )
			{
				cout << " Usage: " << list_of_patterns[i]->getUsage()
					 << " Gaps: " << list_of_patterns[i]->getGaps()
					    		 << " pattern num: " << list_of_patterns[i]->getPatternNum()
								 << " pattern code len: " << list_of_patterns[i]->getPatternCodeLength()
								 << " fill code len: " << list_of_patterns[i]->getFillCodeLength()
								 << " gap code len: " << list_of_patterns[i]->getGapCodeLength()
								 << endl;
			}*/
		}
		flag = 0;
		for(unsigned int i = 0; i < list_of_patterns.size(); i++)
		{
			if( prev_usages[i] != list_of_patterns[i]->getUsage() )
			{
				flag = 1;
			}
			prev_usages[i] = list_of_patterns[i]->getUsage();
		}

		if( count <= 0)
		{
			break;
		}
		else
		{
			count--;
		}

		if( !flag )
		{
			//cout << "Old align gain: " << *sum_gain_val << endl;
		}
		else
		{
			std::fill( selected_win.begin(), selected_win.end(), 0);
		}
	}

}



