# -*- coding: utf-8 -*-

import unittest

import numpy as np

from shsplots.matplotlib.plot_context import PlotContext
from shsplots.matplotlib.histogram import plot_counts
from shsplots.matplotlib.histogram import plot_histogram

class TestHistogram(unittest.TestCase):

    def test_plot_counts(self):
        with PlotContext(show=False):
            plot_counts(['a', 'b', 'b', 'a', 'a', 'c', 'b', 'b', 'b', 'b'])
        with PlotContext(show=False):
            plot_counts(['a', 'b', 'b', 'a', 'a', 'c', 'b', 'b', 'b', 'b'],
                        order_by='frequency_asc')
        with PlotContext(show=False):
            plot_counts(['a', 'b', 'b', 'a', 'a', 'c', 'b', 'b', 'b', 'b'],
                        order_by='frequency_desc')

    def test_plot_histogram(self):
        with PlotContext(show=False):
            plot_histogram(np.random.randn(1000), nr_of_bins=10)

if __name__ == '__main__':
    unittest.main()